unit BrettWin;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Brett, Notation, StdCtrls, MiniMax, PGN,
  SchachProcs, Buttons, Menus, ComCtrls, SyncObjs, uReport,
  uECO, AThread, DialogsLng, TimeLabel, uTimeDlg;

Const WM_ONSTOP = WM_USER + 6;

type
  TAnalyseThread = class(TThread)
  private
    aParent : TForm;
  protected
    procedure Execute; override;
    destructor destroy; override;
  public
    constructor Create(f : TForm);
  end;

  TMDIBrett = class(TForm)
    pButtonLeiste: TPanel;
    pBrett: TPanel;
    pNotation: TPanel;
    Splitter1: TSplitter;
    Notation1: TNotation;
    pBoard: TPanel;
    Brett1: TBrett;
    pNavigation: TPanel;
    pButtons: TPanel;
    sbReplace: TSpeedButton;
    puBrett: TPopupMenu;
    mAufbauen: TMenuItem;
    sbPrev: TSpeedButton;
    sbBack: TSpeedButton;
    sbAhead: TSpeedButton;
    sbNext: TSpeedButton;
    Memo1: TMemo;
    sbSave: TSpeedButton;
    mDiaCopy: TMenuItem;
    puNotation: TPopupMenu;
    mPGNCopy1: TMenuItem;
    mPGNInsert: TMenuItem;
    mFENCopy: TMenuItem;
    mInsertFEN: TMenuItem;
    mDrehen: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N4: TMenuItem;
    N6: TMenuItem;
    N5: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    Nichts1: TMenuItem;
    MiniMax1: TMiniMax;
    mMessages: TMenuItem;
    bPrev: TSpeedButton;
    bNext: TSpeedButton;
    bNew: TSpeedButton;
    mGameData: TSpeedButton;
    bUndo: TSpeedButton;
    bCut: TSpeedButton;
    Blind1: TMenuItem;
    mPrint: TMenuItem;
    puMiniMax: TPopupMenu;
    mStop: TMenuItem;
    MMCheck: TMiniMax;
    puCut: TPopupMenu;
    mPrev: TMenuItem;
    mNext: TMenuItem;
    pPu: TPanel;
    bDelete: TSpeedButton;
    mAufwerten: TSpeedButton;
    bComment: TSpeedButton;
    sbPlay: TSpeedButton;
    pEngines: TPanel;
    sbAnalyse: TSpeedButton;
    puEngines: TPopupMenu;
    TimerEngineReactivate: TTimer;
    bNextMain: TSpeedButton;
    bAutoplay: TSpeedButton;
    AutoplayTimer: TTimer;
    pTime: TPanel;
    tlWhite: TTimeLabel;
    tlBlack: TTimeLabel;
    lFRC: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Timer1: TTimer;
    pForderung: TPanel;
    lForderung: TLabel;
    mStellungsBewertung: TMenuItem;
    Nichts2: TMenuItem;
    N3: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    oo1: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    mKompensation: TMenuItem;
    mGegenspiel: TMenuItem;
    mInitiative: TMenuItem;
    mAngriff: TMenuItem;
    mZeitnot: TMenuItem;
    mEntwicklungsvorsprung: TMenuItem;
    mZugzwang: TMenuItem;
    mEinzigerZug: TMenuItem;
    mNeuerung: TMenuItem;
    mMitderIdee: TMenuItem;
    mBesserist: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Splitter1Moved(Sender: TObject);
    procedure Brett1MoveDone(Sender: TObject);
    procedure Brett1MovePart(Sender: TObject; Teilfeld: Byte;
      var Zugvorschlag: Byte);
    procedure Brett1MoveTry(Sender: TObject; var legal: Boolean);
    procedure Brett1NewPosition(Sender: TObject; Stellung: TSchachbrett;
      Zug: TZug; z: Integer);
    procedure Notation1MoveChange(Sender: TObject; Zug: TZug;
      Stellung: TSchachbrett; NextMove: Boolean);
    procedure Notation13Repetition(Sender: TObject);
    procedure Notation150MovesRule(Sender: TObject);
    procedure sbReplaceClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mAufbauenClick(Sender: TObject);
    procedure Notation1Error(Sender: TObject; Fehlermeldung: String);
    procedure Notation1GameChanged(Sender: TObject);
    procedure sbPrevClick(Sender: TObject);
    procedure sbBackClick(Sender: TObject);
    procedure sbAheadClick(Sender: TObject);
    procedure sbNextClick(Sender: TObject);
    procedure MiniMax1Schach(Sender: TObject);
    procedure MiniMax1Stop(Sender: TObject; var Zug: PZug; Status: Byte);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure sbAnalyseClick(Sender: TObject);
    procedure sbPlayClick(Sender: TObject);
    procedure MiniMax1Trace(Sender: TObject; S: String);
    procedure sbSaveClick(Sender: TObject);
    procedure mDiaCopyClick(Sender: TObject);
    procedure mPGNCopy1Click(Sender: TObject);
    procedure mPGNInsertClick(Sender: TObject);
    procedure mInsertFENClick(Sender: TObject);
    procedure mFENCopyClick(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure Nichts1Click(Sender: TObject);
    procedure mMessagesClick(Sender: TObject);
    procedure mDrehenClick(Sender: TObject);
    procedure bCommentClick(Sender: TObject);
    procedure bNewClick(Sender: TObject);
    procedure mGameDataClick(Sender: TObject);
    procedure bUndoClick(Sender: TObject);
    procedure bCutClick(Sender: TObject);
    procedure bDeleteClick(Sender: TObject);
    procedure mAufwertenClick(Sender: TObject);
    procedure bPrevClick(Sender: TObject);
    procedure bNextClick(Sender: TObject);
    procedure Blind1Click(Sender: TObject);
    procedure Notation1FischerInfo(Sender: TObject;
      FischerInfo: TFischerInfo);
    procedure mPrintClick(Sender: TObject);
    procedure mStopClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure mPrevClick(Sender: TObject);
    procedure mNextClick(Sender: TObject);
    procedure TimerEngineReactivateTimer(Sender: TObject);
    procedure bNextMainClick(Sender: TObject);
    procedure AutoplayTimerTimer(Sender: TObject);
    procedure bAutoplayClick(Sender: TObject);
    procedure tlWhiteClick(Sender: TObject);
    procedure tlWhiteZue(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure tlBlackZue(Sender: TObject);
    procedure Brett1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure lForderungClick(Sender: TObject);
    procedure tlBlackClick(Sender: TObject);
    procedure mZugzwangClick(Sender: TObject);
    procedure Nichts2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure N12Click(Sender: TObject);
    procedure N13Click(Sender: TObject);
    procedure oo1Click(Sender: TObject);
    procedure N14Click(Sender: TObject);
    procedure N15Click(Sender: TObject);
    procedure N16Click(Sender: TObject);
    procedure mKompensationClick(Sender: TObject);
    procedure mGegenspielClick(Sender: TObject);
    procedure mInitiativeClick(Sender: TObject);
    procedure mAngriffClick(Sender: TObject);
    procedure mZeitnotClick(Sender: TObject);
    procedure mEntwicklungsvorsprungClick(Sender: TObject);
    procedure mEinzigerZugClick(Sender: TObject);
    procedure mNeuerungClick(Sender: TObject);
    procedure mMitderIdeeClick(Sender: TObject);
    procedure mBesseristClick(Sender: TObject);
    procedure Brett1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pBoardMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    koord : array[1..16] of TLabel;
    koord1 : array[1..16] of TLabel;
    iDiff : integer;
    NoDrawMessage, InLoop, FinishLoop, ForceMove : Boolean;
    rZug : TZug;
    rStatus : integer;
    slOpenDatabases : TStringlist;
    UntilFlag : TEvent;
    lEval : TList;
    lastFromSquareMarked, lastToSquareMarked : Integer;
    AnalyseThread : TAnalyseThread;
    AnalyseThreadWB : TAnalyseThreadWB;
    procedure SetRect(g : integer);
    function  CheckOpenDatabases : Boolean;
    procedure SaveQuestion;
    procedure IniModul;
    procedure StopModul;
    procedure StopAnalyse;
    procedure DoStop(Var Msg : TMsg); message WM_ONSTOP;
    procedure DoPGNSave(Save : Boolean);
    procedure FischerQuestion;
    function  IniWBEngine(cmdLine : string) : Boolean;
    procedure ChooseModul(Sender: TObject);
    function  StartWBModul(s : String) : Boolean;
    procedure Autoplay(b : Boolean);
    procedure stopClocks;
    procedure pressClocks;
    procedure EnablePlayTimer;
    procedure markSquare(v, n : Integer);
    procedure deleteSquareMarker;
  public
    PGN : TPGN;
    GameID : longint;
    FRC : PFischerInfo;
    procedure SetKoord(v : Boolean);
    procedure setEngineMenu;
    procedure enableNavigation(b : Boolean);
    function  DecodeAnnotator : string;
    procedure SuspendAnalyse;
    procedure ResumeAnalyse;
  end;

var
  MDIBrett: TMDIBrett;

implementation

uses Main, PGNSave, PGNWin, Comment, Local, LocalConst;

{$R *.DFM}

procedure MsgWaitForSingleObject(Handle: THandle);
begin
  repeat
    if MsgWaitForMultipleObjects( 1, Handle, False,  INFINITE, QS_ALLINPUT)
    = WAIT_OBJECT_0 + 1
      then Application.ProcessMessages
      else BREAK;
  until True = False;
end;

Constructor TAnalyseThread.Create(f : TForm);
begin
  aParent := f;
  FreeOnTerminate := true;
  inherited Create(false);
end;

destructor TAnalyseThread.destroy;
Var f : TForm;
begin
  f := aParent;
  inherited destroy;
  (f as TMDIBrett).InLoop := false;
  (f as TMDIBrett).UntilFlag.SetEvent;
end;

procedure TAnalyseThread.Execute;
Var Tiefe : Integer;
begin
  with aParent as TMDIBrett do begin
    repeat
      FinishLoop := true;
      if sbPlay.Down then begin  {Playing mode - disable move input}
        Brett1.ZiehenMoeglich := false;
        enableNavigation(false);
      end;
      Tiefe := Maximal;
      try
        MiniMax1.Start(Brett1.GetBrStellung, Brett1.GetBrZug, Tiefe);
      finally
        Brett1.ZiehenMoeglich := true;
        if not sbPlay.down then
          enableNavigation(true);
      end;
    until FinishLoop;
  end;
end;

procedure TMDIBrett.StopAnalyse;
begin
  if AnalyseThreadWB <> Nil then begin
     AnalyseThreadWB.TerminateWBEngine;
     AnalyseThreadWB.Free;
     AnalyseThreadWB := Nil;
  end
  else if InLoop then begin
    if AnalyseThread.Suspended then AnalyseThread.Resume;
    MiniMax1.BreakLoop;
    MsgWaitForSingleObject(UntilFlag.Handle);
    AnalyseThread := Nil;
  end;
end;

procedure TMDIBrett.SuspendAnalyse;
begin
  if (AnalyseThread <> Nil) and (not AnalyseThread.Suspended) then
    AnalyseThread.Suspend;
  if (AnalyseThreadWB <> Nil) and (not AnalyseThreadWB.Suspended) then
    AnalyseThreadWB.Suspend;
end;

procedure TMDIBrett.ResumeAnalyse;
begin
  if (AnalyseThread <> Nil) and (AnalyseThread.Suspended) then
    AnalyseThread.Resume;
  if (AnalyseThreadWB <> Nil) and (AnalyseThreadWB.Suspended) then
    AnalyseThreadWB.Resume;
end;

procedure TMDIBrett.stopModul;
begin
  try
    TimerEngineReactivate.Enabled := false;
    StopAnalyse;
    sbAnalyse.Down := false;
    Memo1.Visible := false;
    sbPlay.Down := false;
    Timer1.Enabled := false;
    Memo1.Text := '';
  except
  end;  
end;

procedure TMDIBrett.IniModul;
begin
  if sbAnalyse.Down then begin
    if AnalyseThreadWB = Nil then begin
      if not InLoop then begin
        InLoop := True;
        UntilFlag.ResetEvent;
        AnalyseThread := TAnalyseThread.Create(self);
      end
      else begin
        FinishLoop := false;  {then the searching loop will be repeated}
        MiniMax1.BreakLoop;  {Unlike TMiniMax.Stop := TRUE this does not fire the Stop-event}
      end;
    end
    else begin
      TimerEngineReactivate.Enabled := false;
      AnalyseThreadWB.RepeatWBEngine;
      TimerEngineReactivate.Enabled := true;
    end;
  end;
end;

procedure TMDIBrett.markSquare(v, n : Integer);
begin
  if not Mainform.mShowLastMove.Checked then exit;
  deleteSquareMarker;
  Brett1.paintRect(N, clYellow);
  Brett1.paintRect(V, clYellow);
  lastFromSquareMarked := V;
  lastToSquareMarked := N;
end;

procedure TMDIBrett.DoStop(Var Msg : TMsg);
var Gezogen : Boolean;
begin
  try
    if (not sbPlay.Down) and (not ForceMove) then exit; {In analysis mode the space key forces the currently calculated move}
    {if the position is mate, do not play any move (status = matt);
     status = mit_Matt means that the current move leads to a mate - normally show a message then}
    if ((rStatus = legaler_zug) or (rStatus = mit_Schach))
    or (rStatus = mit_Matt) or (rStatus = mit_Patt) then begin
      Gezogen := Notation1.AddZug(rZug);
      if Gezogen then begin   {can be false if the adding of move was cancelled in the variation dialog}
        Brett1.AddZug(rZug);
       {As an alternative: Brett1.Zieh(rZug^.von, rZug^.nach, rZug^.UFigur,
       (Zug.RochadeArt = KURZEFISCHERROCHADE) or (Zug.RochadeArt = LANGEFISCHERROCHADE)); (if the FRC option is not used, you can always write "false" here}
        markSquare(rZug.Von, rZug.Nach);
        Brett1.Ton := false;
        if rStatus = mit_Schach  {Check. In addition, the "OnSchach" has a handler. This event is triggered by Minimax before, if the current position is check}
          then if sbPlay.Down then MessageBeep(MB_ICONEXCLAMATION);
        pressClocks;
        if sbPlay.Down then
          Timer1.Enabled := false;
      end;
      if (Gezogen) and ((rStatus = Matt) or (rStatus = mit_Matt))
      then
        Notation1.Matt; {you must tell it to TNotation to write #}
    end;
    if ((rStatus = Matt) or (rStatus = mit_Matt)) or
    ((rStatus = Patt) or (rStatus = mit_Patt))then
       stopClocks;
    Memo1.Text := '';
  finally
    ForceMove := false;
  end;
end;

procedure TMDIBrett.MiniMax1Stop(Sender: TObject; var Zug: PZug;
  Status: Byte);
begin
  rZug := Zug^;
  rStatus := Status;
  SendMessage(Handle, WM_ONSTOP, 0, 0);
end;

procedure TMDIBrett.sbPlayClick(Sender: TObject);
begin
  pTime.Visible := sbPlay.Down;
  if sbPlay.Down then begin
    StopAnalyse;
    Memo1.Text := '';
    enableNavigation(false);
    Brett1.Zugvorschlagen := false;
    if (tlWhite.MilliSecActual <= 0) or
    (tlBlack.MilliSecActual <= 0) then begin
      tlWhite.SecTotal := MainForm.GameMin * 60;
      tlWhite.SecPerMove := MainForm.MoveSec;
      tlBlack.SecTotal := MainForm.GameMin * 60;
      tlBlack.SecPerMove := MainForm.MoveSec;
    end;
    pressClocks;
  end
  else begin
    IniModul;
    stopClocks;
    enableNavigation(true);
    Brett1.Zugvorschlagen := true;
  end;
end;

procedure TMDIBrett.EnablePlayTimer;
begin
  Timer1.Enabled := true;
  lEval.Clear;
end;

procedure TMDIBrett.pressClocks;
begin
  if not sbPlay.Down then exit;
  if tlWhite.Running or tlBlack.Running then begin
    tlWhite.Punch;
    tlBlack.Punch;
  end
  else begin
    if Brett1.whitesTurn then tlWhite.Start
    else tlBlack.Start;
  end;
end;

procedure TMDIBrett.stopClocks;
begin
  tlWhite.Stop;
  tlBlack.Stop;
  Timer1.Enabled := false;
end;

procedure TMDIBrett.FischerQuestion;
Var Zug : TZug;      {Please note, the setup function does not support Fischer-Random-Chess}
begin
  if not lFRC.Visible then exit;
  Zug := Brett1.GetBrZug;
  if MessageDlgLng(LOGetMess(LO_Handeltessichx),  mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
    SetFischerInfo(FRC, Brett1.GetBrStellung);
    Notation1FischerInfo(self, FRC^);
    Zug.Rochademoeglichkeiten := [wkr, wlr, skr, slr];
  end
  else begin
    Zug.Rochademoeglichkeiten := [];
  end;
  Brett1.SetPosition(Brett1.GetBrStellung, Zug);
  Notation1.NeueStellung(Brett1.GetBrStellung, Zug, Notation1.Partiedaten.Zugnummer);
end;

procedure TMDIBrett.DoPGNSave(Save : Boolean);
Var rPGN : TPGN;
    I : Integer;
begin
  with TfPGNSave.Create(self) do try
    with Notation1.Partiedaten.EventData do begin
      eWeiss.Text := Weiss;
      eSchwarz.Text := Schwarz;
      eQuelle.Text := quelle;
      eSite.Text := Ort;
      sewElo.Value := WElo;
      sesElo.Value := SElo;
      eKommentator.Text := Annotator;
      seJahr.Value := Jahr;
      seMonat.Value := Monat;
      seTag.Value := Tag;
      seRunde.Value := Runde;
      eEco.Text := Eco;
      if Ergebnis = '1-0' then rbGewinn.Checked:=true
      else if Ergebnis = '1/2-1/2' then rbRemis.Checked:=true
      else if Ergebnis = '0-1' then rbVerlust.Checked:=true
      else rbKeinErgebnis.Checked:=true;
      if Save then begin
        cbFileName.Items.Assign(slOpenDatabases);
        cbFileName.Visible := true;
        lFileName.Visible := true;
        cbFileName.Itemindex := cbFileName.Items.IndexOf(MainForm.SaveDataBase);
        if (cbFileName.Itemindex = -1) and (cbFileName.Items.Count > 0) then
          cbFileName.Itemindex := 0;
        bOk.Caption := LOGetMess(LO_Speichern);
      end;
      if (ShowModal = mrOk) and (PGN <> Mainform.tacticPGN) then begin
        Weiss := eWeiss.Text;
        Schwarz := eSchwarz.Text;
        quelle := eQuelle.Text;
        Ort := eSite.Text;
        WElo := sewElo.Value;
        SElo := sesElo.Value;
        Annotator := eKommentator.Text;
        Eco := eEco.Text;
        Jahr := seJahr.Value;
        Monat := seMonat.Value;
        Tag := seTag.Value;
        Runde := seRunde.Value;
        if rbGewinn.Checked then Ergebnis := '1-0'
        else if rbRemis.Checked then Ergebnis := '1/2-1/2'
        else if rbVerlust.Checked then Ergebnis := '0-1'
        else Ergebnis := '*';
        Notation1.NotationRefresh; {important - TNotation does not automatically the refresh}
        if Save then begin
          rPGN := Nil;
          for I := MainForm.MDIChildCount - 1 downto 0 do
            if MainForm.MDIChildren[I] is TMDIPGN then
              if (MainForm.MDIChildren[I] as TMDIPGN).Caption =
              ListboxNameToDatabaseName(cbFileName.Text) then begin
                rPGN := (MainForm.MDIChildren[I] as TMDIPGN).PGN1;
                Break;
              end;
          if not assigned(rPGN) then begin
            MessageDlgLng(LOGetMess(LO_SpeicherFehler), mtError, [mbOk], 0);
            exit;
          end;
          GameID := pgnAddGame;  {Append, not replace}
          PGN := rPGN;
          if not PGN.SaveGame(pgnAddGame, GameID, Notation1.GetGame)
            then MessageDlgLng(LOGetMess(LO_Speicherfehler), mtError, [mbOk], 0)
          else begin
            Notation1.geaendert := false;
            sbReplace.Enabled := false;
            bPrev.Enabled := True;
            bNext.Enabled := True;
            MainForm.SaveDataBase := cbFileName.Text;
          end;
        end
        else begin
          Notation1.geaendert := true;
          sbReplace.Enabled := true;
        end;
        self.Caption := Weiss + ' - ' + Schwarz;
      end;
    end;
  finally
    Free;
  end;
end;

procedure TMDIBrett.sbAnalyseClick(Sender: TObject);
begin
  Memo1.Visible := sbAnalyse.Down;
  if Mainform.tacticPGN <> PGN then
    sbPlay.Enabled := sbAnalyse.Down;
  if sbAnalyse.Down then begin
    if Mainform.slEngines.Count <> 0 then begin
      pEngines.PopupMenu := puEngines;
      pEngines.Perform(WM_RBUTTONDOWN, 0, 0);
      pEngines.Perform(WM_RBUTTONUP, 0, 0);
      pEngines.PopupMenu := Nil;
    end
    else begin
      mStop.Enabled := true;
      IniModul;
    end;  
  end
  else begin
    StopModul;
    stopClocks;
    pTime.Visible := false;
    if Mainform.tacticPGN <> PGN then
      enableNavigation(true);
  end;  
end;

function TMDIBrett.CheckOpenDatabases : Boolean;
Var I : Integer;
begin
  Result := false;
  slOpenDatabases.Clear;
  for I := MainForm.MDIChildCount - 1 downto 0 do
    if MainForm.MDIChildren[I] is TMDIPGN then
      slOpenDatabases.Add(DatabaseNameToListboxName(
        (MainForm.MDIChildren[I] as TMDIPGN).Caption));
  if slOpenDatabases.Count = 0 then begin
    {Since opening of larger pgn files could take a longer while, this is not done automatically here.
     (the function AppendGameToPGN without loading into TPGN just as it is done after Drag&Drop onto a database window doesn't work here,
      because it does not deliver a game ID for the next possible saving)}
    MessageDlgLng(LOGetMess(LO_Bitteoeffnen), mtInformation, [mbOk], 0);
    exit;
  end;
  Result := true;
end;

procedure TMDIBrett.SaveQuestion;
begin
  if not Notation1.Geaendert then exit;
  case MessageDlgLng(Caption + #13 + #13 + LOGetMess(LO_SaveQuestion), mtConfirmation, [mbYes, mbNo, mbCancel], 0) of
    mrCancel : Abort;
    mrYes    :
    if not CheckOpenDatabases then Abort
               else begin
                 sbReplaceClick(self);
                 Mainform.lBackupHint.Visible := false;
                 if Notation1.Geaendert then Abort;
               end;
  end;
end;

procedure TMDIBrett.SetKoord(v : Boolean);
Var i : integer;
begin
  for i := 1 to 16 do begin
    koord[i].Visible := v;
    koord1[i].Visible := v;
    if i < 9 then begin
      koord[i].Visible := v;
      koord[i].top := iDiff shr 1
       - (koord[i].height shr 1) +
      (((i-1) * Brett1.Groesse) + Brett1.Groesse shr 1);
      koord[i].left := iDiff shr 2 - (koord[i].width shr 1);
    end
    else begin
      koord[i].top := Brett1.height + iDiff shr 1
      + iDiff shr 2 - (koord[i].height shr 1);
      koord[i].left := iDiff shr 1
       - (koord[i].width shr 1) +
      (((i-9) * Brett1.Groesse) + Brett1.Groesse shr 1);
    end;
    if i < 9 then begin
      koord1[i].top := iDiff shr 1
       - (koord1[i].height shr 1) +
      (((i-1) * Brett1.Groesse) + Brett1.Groesse shr 1);
      koord1[i].left := Brett1.width + iDiff shr 1 +
      iDiff shr 2 - (koord1[i].width shr 1);
    end
    else begin
      koord1[i].top := iDiff shr 2 - (koord1[i].height shr 1);
      koord1[i].left := iDiff shr 1
       - (koord1[i].width shr 1) +
      (((i-9) * Brett1.Groesse) + Brett1.Groesse shr 1);
    end;
  end;
end;

procedure TMDIBrett.SetRect(g : integer);
begin
  Brett1.Groesse := g;
  case g of
 //   16 : Brett1.Figuren := F16;
    21 : Brett1.Figuren := WinboardF21;
    25 : Brett1.Figuren := WinboardF25;
    29 : Brett1.Figuren := WinboardF29;
    33 : Brett1.Figuren := WinboardF33;
    37 : Brett1.Figuren := WinboardF37;
    40 : Brett1.Figuren := WinboardF40;
    45 : Brett1.Figuren := WinboardF45;
    49 : Brett1.Figuren := WinboardF49;
    54 : Brett1.Figuren := WinboardF54;
    58 : Brett1.Figuren := WinboardF58;
    64 : Brett1.Figuren := WinboardF64;
    72 : Brett1.Figuren := WinboardF72;
    80 : Brett1.Figuren := WinboardF80;
    else Brett1.Figuren := WinboardF21;//WinboardF40;
  end;
  pBoard.Height := (g shl 3) + iDiff;
  pBoard.Width := (g shl 3) + iDiff;
  pNavigation.Top := pBoard.Height + 2;
  pNavigation.Left := (pBoard.Width shr 1) - (pNavigation.Width shr 1);
  SetKoord(true);
end;

procedure TMDIBrett.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TMDIBrett.FormCreate(Sender: TObject);
Var i : integer;

function smallfonts : boolean;
Var DC : HDC;
begin
  DC := GetDC(0);
  Result := (GetDeviceCaps(DC, LOGPIXELSX) = 96);
  ReleaseDC(0, DC);
end;

begin
  lastFromSquareMarked := -1;
  lastToSquareMarked := -1;
  Brett1.MarkedSquareColor := clYellow;
  Brett1.ClickAndClick := MainForm.mClickClick.Checked;
  if MainForm.Brettheight > 100 then Height := MainForm.Brettheight;
  if MainForm.Brettwidth > 100 then Width := MainForm.Brettwidth;
  if MainForm.BrettSize > 50 then
    pBrett.Width := MainForm.BrettSize;
  if MainForm.BlackSquare <> 0 then Brett1.BlackSquareColor := MainForm.BlackSquare;
  if MainForm.WhiteSquare <> 0 then Brett1.WhiteSquareColor := MainForm.WhiteSquare;
  if (MainForm.BrettTop >= 0) and (MainForm.BrettTop + Height < Mainform.ClientHeight - Mainform.Panel1.Height)
    then Top := MainForm.BrettTop
  else Top := 0;  
  if (MainForm.BrettLeft >= 0) and (MainForm.BrettLeft + Width < Mainform.ClientWidth)
    then Left := MainForm.BrettLeft
  else Left := 0;
  if MainForm.BrettState <> wsMinimized then begin
    WindowState := MainForm.BrettState;
  end;
  Brett1.SetFigurenset(Mainform.hBrett.GetFigurenset, User);  {faster then extracting the compressed pieces set again - property Figuren must be set to USER in this case}
  for i := 1 to 16 do begin
    koord[i] := TLabel.Create(self);
    koord[i].Parent := pBoard;
    koord[i].Transparent := true;
    if i < 9 then koord[i].caption := Inttostr(abs(i - 9))
    else koord[i].caption := chr(i + 56);
    koord1[i] := TLabel.Create(self);
    koord1[i].Parent := pBoard;
    koord1[i].Transparent := true;
    if i < 9 then koord1[i].caption := Inttostr(abs(i - 9))
    else koord1[i].caption := chr(i + 56);
  end;
  idiff := pBoard.Bevelwidth shl 2 + pBoard.Borderwidth shl 1;
  {TBrett does not adjust its dimensions for the system property 'Big font size' (because the pictures would be streched) -
   therefore adjust the "environment"}
  Brett1.LockBoardUpdate := true;
  Brett1.Left := pBoard.Bevelwidth shl 1 + pBoard.Borderwidth;
  Brett1.Top := pBoard.Bevelwidth  shl 1 + pBoard.Borderwidth;
  Brett1.Height := Brett1.Groesse shl 3;
  Brett1.Width := Brett1.Groesse shl 3;  { important: The dimensions of TImage are adjusted for "Big font size" - it must be reseted, otherwise the entire image would completely be repainted (flicker) after any changes }
  pBoard.Width := Brett1.Width + idiff;
  pBoard.Height := Brett1.Height + idiff;
  if MainForm.WhiteOnTop then
    mDrehenClick(Self);
  Brett1.LockBoardUpdate := false;
  MiniMax1.NoCheckMessages := True;  {otherwise "Application.ProcessMessages would be called - it's not necessary with threads}
  slOpenDatabases := TStringlist.Create;
  with MainForm, Notation1 do begin
    Font0Var := FontDialog1.Font;
    FontComment := FontDialogComm.Font;
    SetPiecesnames(figK, figQ, figR, figB, figN, figP);
    SetInformantSigns(InformantSigns);
  end;

  {'Assign' is not necessary, because it is done by the component method (in addition, it assignes the properties to the fonts of 1. and 2. variation -
  different fonts must not be used)
  Important: In FontDialog fdNoSimulations must be TRUE, because some font styles could lead to errors if the current move is marked}
  New(FRC);
  if not Mainform.mAnimation.Checked then Brett1.Animation := 0;
  UntilFlag  := TEvent.Create(Nil, True, False, '');
  lEval := TList.Create;
  tlWhite.SecTotal := MainForm.GameMin * 60;
  tlWhite.SecPerMove := MainForm.MoveSec;
  tlBlack.SecTotal := MainForm.GameMin * 60;
  tlBlack.SecPerMove := MainForm.MoveSec;
  if LO_lng = LO_English then Notation1.English := true;
  if Mainform.mToolbarBelow.Checked then
    pButtonLeiste.Align := alBottom;
  LOSaveBrettWinStrings(self);
 // hNotation.checkMoves := true; {checks the game for errors while loading}
end;

procedure TMDIBrett.FormDestroy(Sender: TObject);
Var i : integer;
begin
  try
    lEval.Free;
    for i := 1 to 16 do begin
      koord[i].free;
      koord1[i].free;
    end;
    slOpenDatabases.Free;
    Dispose(FRC);
    UntilFlag.Free;
  except
  end;  
end;

procedure TMDIBrett.Splitter1Moved(Sender: TObject);
Var i : integer;
begin
    i := abs(Splitter1.Left - iDiff) shr 3;
    if i >= 80 then SetRect(80)
    else if i >= 72 then SetRect(72)
    else if i >= 64 then SetRect(64)
    else if i >= 58 then SetRect(58)
    else if i >= 54 then SetRect(54)
    else if i >= 49 then SetRect(49)
    else if i >= 45 then SetRect(45)
    else if i >= 40 then SetRect(40)
    else if i >= 37 then SetRect(37)
    else if i >= 33 then SetRect(33)
    else if i >= 29 then SetRect(29)
    else if i >= 25 then SetRect(25)
    else if i >= 21 then SetRect(21)
    else SetRect(16);
end;

procedure TMDIBrett.Brett1MoveDone(Sender: TObject);
Var gezogen : Boolean;
begin
  Notation1.AltPressed := Brett1.AltPressed;  //ccf
  Notation1.CtrlPressed := Brett1.CtrlPressed;
  gezogen := Notation1.AddZug(Brett1.GetBrZug);
  if gezogen then begin
    if MMCheck.IsMatt(Brett1.GetBrStellung, Brett1.GetBrZug)
      then Notation1.Matt;
    IniModul;         
    pressClocks;
    if sbPlay.Down then
      EnablePlayTimer;
  end;
end;

procedure TMDIBrett.Brett1MovePart(Sender: TObject; Teilfeld: Byte;
  var Zugvorschlag: Byte);
begin
  Zugvorschlag := MMCheck.Vorschlag(Brett1.GetBrStellung, Brett1.GetBrZug, Teilfeld);
end;

procedure TMDIBrett.Brett1MoveTry(Sender: TObject; var legal: Boolean);
begin
  legal :=  MMCheck.IstZugLegal(Brett1.GetBrStellung, Brett1.GetBrZug);
end;

procedure TMDIBrett.Brett1NewPosition(Sender: TObject;
  Stellung: TSchachbrett; Zug: TZug; z: Integer);
begin
  Notation1.NeueStellung(Stellung, Zug, z); {z = first move number}
  if not sbPlay.Down then IniModul;
end;

procedure TMDIBrett.Notation1MoveChange(Sender: TObject; Zug: TZug;
  Stellung: TSchachbrett; NextMove: Boolean);
var z : TZug;
begin
  deleteSquareMarker;
  if NextMove then begin  {only because a move animation is executed}
    Brett1.Zieh(Zug.von, Zug.nach, Zug.Ufigur,
    (Zug.RochadeArt = KURZEFISCHERROCHADE) or (Zug.RochadeArt = LANGEFISCHERROCHADE));
  end
  else
    Brett1.SetPosition(Stellung, Zug);
  if (not NextMove) or (Brett1.Animation = 0) then begin
    z := Brett1.GetBrZug;
    if z.von <> 0 then
      markSquare(z.von, z.nach);
  end;    
  if not sbPlay.Down then IniModul;
end;

procedure TMDIBrett.Notation13Repetition(Sender: TObject);
begin
  if not NoDrawMessage then ShowMessage(LOGetMess(LO_facheStellungswiederholung));
end;

procedure TMDIBrett.Notation150MovesRule(Sender: TObject);
begin
  if not NoDrawMessage then ShowMessage(LOGetMess(LO_ZuegeRegel));
end;

procedure TMDIBrett.sbReplaceClick(Sender: TObject);
begin
  if MainForm.Working then exit;
  if not Notation1.Geaendert then exit;
  if assigned(PGN) then begin
    {if ID = pgnAddGame = -1 the game would be appended automatically and a valid ID would be returned}
    MainForm.Abbrechen := false;
    Mainform.lBackupHint.Visible := true;
    Mainform.log('Replace ' + IntToStr(GameID));
    if PGN.ReplaceGame(GameID, Notation1.GetGame) then begin
      sbReplace.Enabled := false;
      Notation1.Geaendert := false;
    end
    else
      MessageDlgLng(LOGetMess(LO_SpeicherFehler), mtError, [mbOk], 0);
    Mainform.lBackupHint.Visible := false;
  end
  else sbSaveClick(self);
end;

(*procedure TMDIBrett.checkMemo;
var s, sZug : String;
    i : Integer;
begin
  try
    s := Memo1.Text;
    i := Pos(#10, s);
    if i = -1 then exit;
    inc(i);
    while (i <= length(s)) and (not (s[i] in ['A'..'Z', 'a'..'z', '0'])) do
      inc(i);
    sZug := '';
    while (i <= length(s)) and (s[i] <> ' ') do begin
      sZug := sZug + s[i];
      inc(i);
    end;
    s := Notation1.getGame;
    i := length(s);
    while (i > 0) and (s[i] <> '-') and (s[i] <> '*') do dec(i);
    while (i > 0) and (s[i] <> ' ') do dec(i);
    insert(' ' + sZug + ' ', s, i);
    if hNotation.SetGame(s) = 0 then
      hNotation.goToEnd; {lst Ereignis hNotationMoveChange aus}
  except
  end;
end;*)

(*       procedure TMDIBrett.WndProc(var MsgRec: TMessage);
begin
  case MsgRec.Msg of
    WM_KEYDOWN: begin messagebeep(0);end;
    WM_KEYUP: begin messagebeep(0);end;
  end;
  inherited WndProc(MsgRec);
end;*)

procedure TMDIBrett.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  keypreview := false;
  case key of
    37, 39, 38, 40, 33, 34, 35, 36 :   {In TNotation can be navigated by the cursor keys}
    begin
      SendMessage(Notation1.Handle, WM_KEYDOWN, key, 0);
      key := 0;
    end;
    32 : if AnalyseThreadWB = Nil then begin
           if InLoop then begin
             if not sbPlay.Down then FinishLoop := false;
             ForceMove := True;
             MiniMax1.Stop:=True;  {Space starts and stops}
           end
           else begin
             IniModul;
             if sbPlay.Down then
               EnablePlayTimer;
           end;
         end;
      (*   else
           if sbAnalyse.Down then
             checkMemo;*)
    27 : Close;     
  end;
  keypreview := true;
end;

procedure TMDIBrett.mAufbauenClick(Sender: TObject);
begin
 // if Brett1.Aufbauen(false) then FischerQuestion;  {Aufbauen lst OnNewPosition aus, wo Notation akt. wird}
//   Brett1.FRC := FRC;  // mu nur <> nil sein - dann werden bei FRC Stllg. Rochademglichkeiten gesetzt
   Brett1.Aufbauen(false); {This function triggers "OnNewPosition"}
end;

procedure TMDIBrett.Notation1Error(Sender: TObject; Fehlermeldung: String);
begin
  MessageDlgLng(Fehlermeldung, mtError, [mbOk], 0);
end;

procedure TMDIBrett.Notation1GameChanged(Sender: TObject);
begin
  sbReplace.Enabled := true;
end;

procedure TMDIBrett.sbPrevClick(Sender: TObject);
begin
  Notation1.GoPreviousVar;
end;

procedure TMDIBrett.sbBackClick(Sender: TObject);
begin
  Notation1.GoBack;
end;

procedure TMDIBrett.sbAheadClick(Sender: TObject);
begin
  Notation1.GoAhead;
end;

procedure TMDIBrett.sbNextClick(Sender: TObject);
begin
  Notation1.GoNextVar;
end;

procedure TMDIBrett.MiniMax1Schach(Sender: TObject);
begin
  Messagebeep(MB_ICONEXCLAMATION);
end;

procedure TMDIBrett.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := false;
  if MainForm.Working then exit;
  SaveQuestion;
  StopAnalyse;
  CanClose := true;
  if WindowState = wsNormal then begin
    MainForm.Brettheight := height;
    MainForm.Brettwidth := Width;
    MainForm.BrettTop := Top;
    MainForm.BrettLeft := Left;
  end;
  MainForm.BrettSize := pBrett.Width;
  if WindowState <> wsMiniMized then 
    MainForm.BrettState := WindowState;
  MainForm.WhiteOnTop := Brett1.WhiteOnTop;
  MainForm.BlackSquare := Brett1.BlackSquareColor;
  MainForm.WhiteSquare := Brett1.WhiteSquareColor;
  if Mainform.tacticPGN = PGN then
    Mainform.mKombis.Enabled := true;
end;

procedure TMDIBrett.MiniMax1Trace(Sender: TObject; S: String);
var i : Integer;
begin
  if sbPlay.Down then begin
    i := Pos(#13, S);
    if i <> -1 then Memo1.Text := copy(S, 1, i - 1)
    else Memo1.Text := S;
  end
  else Memo1.Text := S;
end;

procedure TMDIBrett.sbSaveClick(Sender: TObject);
begin
  if MainForm.Working then exit;
  if not CheckOpenDatabases then begin
    Mainform.mHistoryClick(self);
    exit;
  end;
  DoPGNSave(True);
end;

procedure TMDIBrett.mDiaCopyClick(Sender: TObject);
begin
  Brett1.CopyPictureToClipboard;
end;

procedure TMDIBrett.mPGNCopy1Click(Sender: TObject);
begin
  Notation1.CopyGameToClipboard;
end;

procedure TMDIBrett.mPGNInsertClick(Sender: TObject);
begin
  SaveQuestion;
  Notation1.PasteGameFromClipBoard; {"IniModul" (the engine) in OnMoveChange}
  with Notation1.Partiedaten.EventData do
    Caption := Weiss + ' - ' + Schwarz;
end;

procedure TMDIBrett.mInsertFENClick(Sender: TObject);
begin
  SaveQuestion;
  Brett1.PasteFENFromClipboard; {"IniModul" in OnNewPosition}
  FischerQuestion;
end;

procedure TMDIBrett.mFENCopyClick(Sender: TObject);
begin
  Brett1.CopyFENToClipboard;
end;

procedure TMDIBrett.N6Click(Sender: TObject);
begin
  Notation1.SetZugBewertung('!');
end;

procedure TMDIBrett.N5Click(Sender: TObject);
begin
  Notation1.SetZugBewertung('?');
end;

procedure TMDIBrett.N7Click(Sender: TObject);
begin
  Notation1.SetZugBewertung('!!');
end;

procedure TMDIBrett.N8Click(Sender: TObject);
begin
  Notation1.SetZugBewertung('??');
end;

procedure TMDIBrett.N9Click(Sender: TObject);
begin
  Notation1.SetZugBewertung('!?');
end;

procedure TMDIBrett.N10Click(Sender: TObject);
begin
  Notation1.SetZugBewertung('?!');
end;

procedure TMDIBrett.Nichts1Click(Sender: TObject);
begin
  Notation1.SetZugBewertung('');
end;

procedure TMDIBrett.mMessagesClick(Sender: TObject);
begin
  NoDrawMessage := not mMessages.Checked;
end;

procedure TMDIBrett.mDrehenClick(Sender: TObject);
Var i : Integer;
begin
  For i := 1 to 8 do begin
    koord[i].Caption := IntToStr(abs(StrToInt(koord[i].Caption) - 9));
    koord1[i].Caption := IntToStr(abs(StrToInt(koord1[i].Caption) - 9));
  end;
  For i := 9 to 16 do begin
    koord[i].Caption := Chr(abs(Ord(koord[i].Caption[1]) - 73) + 64);
    koord1[i].Caption := Chr(abs(Ord(koord1[i].Caption[1]) - 73) + 64);
  end;
  Brett1.Drehen;
  SetKoord(true);
end;

procedure TMDIBrett.bCommentClick(Sender: TObject);
begin
  with TKomm.Create(self) do try
    Memo1.Text := Notation1.GetKommentar;
    if ShowModal = mrOK
      then Notation1.SetKommentar(Memo1.Text);
  finally
    Free;
  end;
end;

procedure TMDIBrett.bNewClick(Sender: TObject);
begin
  if Mainform.tacticPGN = PGN then begin
    exit;
  end;
  SaveQuestion;
  Notation1.IniPartie;
  if lFRC.Visible then begin
    Brett1.SetPosition(GetFischerRandomPosition, Brett1.GetBrZug);
    SetFischerInfo(FRC, Brett1.GetBrStellung);
    Notation1.NeueStellung(Brett1.GetBrStellung, Brett1.GetBrZug, 1);
  end;
  with Notation1.Partiedaten.EventData do
    Caption := Weiss + ' - ' + Schwarz;
  GameID := pgnAddGame; //.
  PGN := Nil;           //.
end;

procedure TMDIBrett.mGameDataClick(Sender: TObject);
begin
  DoPGNSave(false);
end;

procedure TMDIBrett.bUndoClick(Sender: TObject);
begin
  Notation1.UnDo;
end;

procedure TMDIBrett.bCutClick(Sender: TObject);
begin
  pPu.Popupmenu := puCut;
  pPu.Perform(WM_RBUTTONDOWN, 0, 0);
  pPu.Perform(WM_RBUTTONUP, 0, 0);
  pPu.Popupmenu := Nil;
end;

procedure TMDIBrett.bDeleteClick(Sender: TObject);
begin
  Notation1.loeschen;
end;

procedure TMDIBrett.mAufwertenClick(Sender: TObject);
begin
  Notation1.aufwerten;
end;

procedure TMDIBrett.bPrevClick(Sender: TObject);
Var i, ID : longint;
    s : String;
begin
  if not assigned(PGN) then exit;
  if PGN.Items.count = 0 then exit;
  if Mainform.tacticPGN = PGN then begin
    i := gameID;
    if i >0 then
      dec(i)
    else begin
      MessageBeep(0);
      i := Mainform.lf.Count - 1;
    end;
    gameID := i;
    i := longint(Mainform.lf[i]);
  end
  else begin
    SaveQuestion;
    if PGN.Itemindex = -1 then begin
      if PGN.ItemsVisibleCount = 0 then exit
      else i := PGN.ItemsVisibleCount - 1;
    end
    else begin
      if PGN.Itemindex = 0 then begin
        MessageBeep(0);
        i := PGN.ItemsVisibleCount - 1;
      end
      else i := PGN.Itemindex - 1;
    end;
    PGN.Selected[PGN.Itemindex] := False;
    PGN.Selected[i] := true;
    PGN.Itemindex := i;
  end;
  s := PGN.GetGameAsString(PGN.ListeIndexToDatabaseIndex(i), ID);
  if s <> '' then begin
    Notation1.SetGame(s);
    with Notation1.Partiedaten.EventData do
      Caption := Weiss + ' - ' + Schwarz;
    if Mainform.tacticPGN <> PGN then
      GameID := ID
    else begin
      pForderung.Visible := true;
      lForderung.Caption := DecodeAnnotator;
    end;
  end;
end;

procedure TMDIBrett.bNextClick(Sender: TObject);
Var i, ID : longint;
    s : String;
begin
  if not assigned(PGN) then exit;
  if PGN.Items.count = 0 then exit;
  if Mainform.tacticPGN = PGN then begin
    i := gameID;
    if i < Mainform.lf.Count - 1 then
      inc(i)
    else begin
      MessageBeep(0);
      i := 0;
    end;
    gameID := i;
    i := longint(Mainform.lf[i]);
  end
  else begin
    SaveQuestion;
    if PGN.Itemindex = -1 then begin
      if PGN.ItemsVisibleCount = 0 then exit
      else i := 0;
    end
    else begin
      if PGN.Itemindex = PGN.ItemsVisibleCount - 1 then begin
        MessageBeep(0);
        i := 0;
      end
      else i := PGN.Itemindex + 1;
    end;
    PGN.Selected[PGN.Itemindex] := False;
    PGN.Selected[i] := true;
    PGN.Itemindex := i;
  end;
  s := PGN.GetGameAsString(PGN.ListeIndexToDatabaseIndex(i), ID);
  if s <> '' then begin
    Notation1.SetGame(s);
    with Notation1.Partiedaten.EventData do
      Caption := Weiss + ' - ' + Schwarz;
    if Mainform.tacticPGN <> PGN then
      GameID := ID
    else begin
      pForderung.Visible := true;
      lForderung.Caption := DecodeAnnotator;
    end;
  end;
end;

function  TMDIBrett.DecodeAnnotator : string;
Var s : string;
    i : integer;
begin
  Result := '';
  with Notation1.Partiedaten.EventData do begin
    if Annotator = '' then exit;
    if Annotator[1] <> 'T' then exit;
    if Notation1.Partiedaten.Zug.amZug = 1 then Result := LOGetMess(LNG_Weisszieht)
    else Result := LOGetMess(LNG_Schwarzzieht);
    if Ergebnis = '1/2-1/2' then s := LOGetMess(LNG_undHaelt)
    else s := LOGetMess(LNG_undGewinnt);
    if Pos('+', Annotator) <> 0 then s := LOGetMess(LNG_undErreicht)
    else if Pos('!', Annotator) <> 0 then s := LOGetMess(LNG_undErhaelt)
    else if Pos('=', Annotator) <> 0 then s := LOGetMess(LNG_undWickelt)
 (*   else if Pos('#', Annotator) <> 0 then begin
      try
        i := StrToInt(copy(Annotator, Pos('#', Annotator) + 1, length(Annotator)));
        if language = LNG_German then s := 'und setzt in ' + IntToStr(i) + ' Zgen matt!'
        else s := 'and mate in ' + IntToStr(i);
      except
      end;
    end      *)
    else if not ((length(Annotator) > 1) and (Annotator[2] in ['1'..'5', 'v', 'V'])) then begin
      Result := '';
      exit;
    end;
    Result := Result + ' ' + s;
  end;
end;

procedure TMDIBrett.Blind1Click(Sender: TObject);
begin
  Blind1.Checked := not Blind1.Checked;
  Brett1.Blind := Blind1.Checked;
  Brett1.BoardRefresh;
end;

procedure TMDIBrett.Notation1FischerInfo(Sender: TObject;
  FischerInfo: TFischerInfo);
begin
  if Fischerinfo.Enabled then begin  {called, after TNotation loaded a Fischer-Random-Chess game}
    FRC^ := Fischerinfo;
    Brett1.FRC := FRC;
    Notation1.FRC := FRC;
    MiniMax1.FRC := FRC;
    MMCheck.FRC := FRC;
    lFRC.Visible := true;
 //   bNew.Enabled := false;
  end
  else begin
    Brett1.FRC := Nil;
    Notation1.FRC := Nil;
    MiniMax1.FRC := Nil;
    MMCheck.FRC := Nil;
    lFRC.Visible := false;
  end;
end;

procedure TMDIBrett.mPrintClick(Sender: TObject);
begin
  with TfrmReport.Create(self) do try
    QRChessRichText1.FEN := PosToFEN(Brett1.GetBrStellung, Brett1.GetBrZug, 1, Nil);
    Tag := 1;
    ChessReport.Print;
  finally
    free;
  end;
end;

procedure TMDIBrett.mStopClick(Sender: TObject);
begin
  if AnalyseThreadWB <> Nil then exit;
  if mStop.Caption = 'Stop' then begin
    if not InLoop then exit;
    mStop.Caption := LOGetMess(LO_Weiter);
    pBrett.Enabled := false;
    Notation1.Enabled := false;
    pButtons.Enabled := false;
    AnalyseThread.Suspend;
    Memo1.WordWrap := false;
    Memo1.Lines.Insert(0, LOGetMess(LO_RECHTEMAUSTASTE));
  end
  else begin
    mStop.Caption := 'Stop';
    pBrett.Enabled := True;
    Notation1.Enabled := True;
    pButtons.Enabled := True;
    if not InLoop then exit;
    if Memo1.Lines.Count <> 0 then Memo1.Lines.Delete(0);
    Memo1.WordWrap := true;
    if AnalyseThread.Suspended then AnalyseThread.Resume;
  end
end;

procedure TMDIBrett.FormShow(Sender: TObject);
begin
  if LO_lng <> LO_German then LOLoadBrettWinStrings(LO_lng, self);
end;

procedure TMDIBrett.mPrevClick(Sender: TObject);
begin
  Notation1.schneide(false);
end;

procedure TMDIBrett.mNextClick(Sender: TObject);
begin
  Notation1.schneide(true);
end;

function TMDIBrett.IniWBEngine(cmdLine : string) : Boolean;
Var hChildStdinRd, hChildStdinWr,
    hChildStdoutRd, hChildStdoutWr,
    hChildStdinWrDup, hChildStdoutRdDup : THANDLE;
    saAttr : TSECURITYATTRIBUTES ;
    fSuccess: Boolean;
    piProcInfo: TPROCESSINFORMATION;
    siStartInfo : TSTARTUPINFO;

begin
  Result := false;
  if not FileExists(cmdLine) then exit;
  cmdLine := cmdLine + ' ' + Mainform.WBInfo.WBParam;

  saAttr.nLength := sizeof(TSECURITYATTRIBUTES);
  saAttr.bInheritHandle := TRUE;
  saAttr.lpSecurityDescriptor := NIL;
  if not CreatePipe(hChildStdoutRd, hChildStdoutWr, @saAttr, 0)
    then exit;
  fSuccess := DuplicateHandle(GetCurrentProcess, hChildStdoutRd,
			     GetCurrentProcess, @hChildStdoutRdDup, 0,
			     FALSE,
			     DUPLICATE_SAME_ACCESS);
  if not fSuccess then exit;
  CloseHandle(hChildStdoutRd);

  if not CreatePipe(hChildStdinRd, hChildStdinWr, @saAttr, 0)
    then exit;

  fSuccess := DuplicateHandle(GetCurrentProcess, hChildStdinWr,
			     GetCurrentProcess, @hChildStdinWrDup, 0,
			     FALSE,
			     DUPLICATE_SAME_ACCESS);
  if not fSuccess then exit;
  CloseHandle(hChildStdinWr);

  siStartInfo.cb := sizeof(TSTARTUPINFO);
  siStartInfo.lpReserved := NIL;
  siStartInfo.lpDesktop := NIL;
  siStartInfo.lpTitle := NIL;
  siStartInfo.dwFlags := STARTF_USESTDHANDLES;
  siStartInfo.cbReserved2 := 0;
  siStartInfo.lpReserved2 := NIL;
  siStartInfo.hStdInput := hChildStdinRd;
  siStartInfo.hStdOutput := hChildStdoutWr;
  siStartInfo.hStdError := hChildStdoutWr;;
  fSuccess := CreateProcess(NIL,
			   PChar(cmdLine),
			   NIL,
			   NIL,
			   TRUE,
			   DETACHED_PROCESS or CREATE_NEW_PROCESS_GROUP,
			   NIL,
			   NIL,
			   siStartInfo,
			   piProcInfo);
  CloseHandle(hChildStdinRd);
  CloseHandle(hChildStdoutWr);
  if not fSuccess then exit;

  with MainForm.WBInfo do begin
    hProcess := piProcInfo.hProcess;
    pid := piProcInfo.dwProcessId;
    hFrom := hChildStdoutRdDup;
    hTo := hChildStdinWrDup;
  end;
  Result := true;
end;

procedure TMDIBrett.setEngineMenu;
var i : Integer;

  procedure AddMenuItem(sCaption : String; j : Integer);
  Var MyPopupItem : TMenuItem;
      s : string;
  begin
    MyPopUpItem := TMenuItem.Create(Self);
    MyPopUpItem.Caption := sCaption;
    MyPopUpItem.Tag := j;
    MyPopUpItem.OnClick := ChooseModul;
    s := IntToStr(j + 1);
    MyPopUpItem.ShortCut := ShortCut(Word(s[1]), [ssCtrl]);
    puEngines.Items.Add(MyPopUpItem);
  end;

begin
  with Mainform do begin
    while puEngines.Items.Count > 0 do
      puEngines.Items.Delete(0);
    AddMenuItem('MiniMax', 0);
    for i := 0 to slEngines.Count - 1 do
      AddMenuItem(ExtractFilename(slEngines[i]), i + 1);
  end;
end;

procedure TMDIBrett.ChooseModul(Sender: TObject);
Var i : integer;
begin
  i := (Sender as TMenuItem).Tag;
  if i = 0 then begin
    mStop.Enabled := true;
    Memo1.Hint := 'Minimax 1.0';
    iniModul;
  end
  else begin
    dec(i);
    if (i < 0) or (i > Mainform.slEngines.Count - 1) then
      exit;
    mStop.Enabled := false;
    if not StartWBModul(Mainform.slEngines[i]) then begin
      sbAnalyse.Down := false;
      Memo1.Visible := false;
      sbPlay.Enabled := false;
    end
    else TimerEngineReactivate.Tag := i;   
  end;
end;

function TMDIBrett.StartWBModul(s : String) : Boolean;

  function GetCraftyFile : string;
  Var j : integer;
      s, s1 : string;
  begin
    Result := '';
    try
      s1 := ExtractFilePath(cmdLine);
      j := 0;
      s := '';
      repeat
        inc(j);
        s := IntToStr(j);
        while length(s) < 3 do s := '0' + s;
      until not FileExists(s1 + 'game.' + s);
      Result := s1 + 'game.' + s;
    except
    end;
  end;

begin
  if Pos('CRAFTY', uppercase(ExtractFilename(s))) = 0 then begin
    Mainform.WBInfo.CraftyFile := '';
    if not Mainform.UserdefinedEngineParam then
    with Mainform.WBInfo do begin
      WBParam       := 'hash=1000000';
      WBIni         := 'xboard' + #13#10 + 'force' + #13#10;
      WbSetBoard    := 'edit';
      WbStartAnalyze:= 'post' + #13#10 + 'go' + #13#10;
      WbStopAnalyze := '?' + #13#10;
      WbQuit        := 'quit' + #13#10;
      WbGetstate    := '.' + #13#10;
      WbNoParseOutput := false;
    end;
  end
  else begin
    Mainform.setWBDefaults;
    Mainform.WBInfo.CraftyFile := GetCraftyFile;  { Crafty creates a file 'game.001' in the current folder - it should be deleted then}
  end;
  Result := iniWBEngine(s);
  if Result then begin
    sbPlay.Enabled := false;  { The playing mode must be deactivated when using a Winboard engine - the "playing protocol functions" are not supported }
    Memo1.Hint := ExtractFilename(s);
    AnalyseThreadWB := TAnalyseThreadWB.Create(self, Mainform.WBInfo);
  end;
end;

procedure TMDIBrett.TimerEngineReactivateTimer(Sender: TObject);
begin
  if not sbAnalyse.Down then exit;
  if (Memo1.Text <> '') and (Memo1.Text[1] = '-') then begin //dann hngt es irgendwie ('- initialize')
    StopAnalyse;
    StartWBModul(Mainform.slEngines[TimerEngineReactivate.Tag]);
  end;
end;

procedure TMDIBrett.bNextMainClick(Sender: TObject);
var  von, nach, ufigur, RochadeArt : shortint;
begin
  if Notation1.Goahead_inHauptVariante(von, nach, ufigur, RochadeArt) then begin
    if AnalyseThreadWB = Nil then
      StopAnalyse;
    Brett1.zieh(von, nach, ufigur,
      (RochadeArt = KURZEFISCHERROCHADE) or (RochadeArt = LANGEFISCHERROCHADE));
    iniModul;
  end
  else
    Autoplay(false)
end;

procedure TMDIBrett.AutoplayTimerTimer(Sender: TObject);
begin
  bNextMainClick(Self);
end;

procedure TMDIBrett.bAutoplayClick(Sender: TObject);
begin
  if not AutoplayTimer.Enabled then begin
    Autoplay(true);
    bNextMainClick(Self);
  end
  else
    Autoplay(false);
end;

procedure TMDIBrett.Autoplay(b : Boolean);
begin
  if b then begin
    bAutoplay.Caption := 'S';
    AutoplayTimer.Enabled := true;
    Brett1.ZiehenMoeglich := false;
  end
  else begin
    bAutoplay.Caption := 'A';
    AutoplayTimer.Enabled := false;
    Brett1.ZiehenMoeglich := true;
  end;
end;

procedure TMDIBrett.tlWhiteClick(Sender: TObject);
begin
  with TTimeDlg.Create(self) do try
    SpinEdit1.Value := MainForm.GameMin;
    SpinEdit2.Value := MainForm.MoveSec;
    if Showmodal = mrOk then begin
      tlWhite.SecTotal := SpinEdit1.Value * 60;
      tlWhite.SecPerMove := SpinEdit2.Value;
      MainForm.GameMin := SpinEdit1.Value;
      MainForm.MoveSec := SpinEdit2.Value;
      if not cbOnlyOneClock.Checked then begin
        tlBlack.SecTotal := SpinEdit1.Value * 60;
        tlBlack.SecPerMove := SpinEdit2.Value;
      end;
    end;
  finally
    free;
  end;
end;

procedure TMDIBrett.enableNavigation(b : Boolean);
begin
  Notation1.Enabled := b;
  pNavigation.Enabled := b;
  mAufbauen.Enabled := b;
  mPGNInsert.Enabled := b;
  mInsertFEN.Enabled := b;
  bCut.Enabled := b;
  bPrev.Enabled := b;
  bNext.Enabled := b;
  bDelete.Enabled := b;
  bNew.Enabled := b;
  bUndo.Enabled := b;
end;

procedure TMDIBrett.tlWhiteZue(Sender: TObject);
begin
  StopClocks;
  MiniMax1.Stop := true;
  MessageDlgLng(LOGetMess(LOZueWhite), mtInformation, [mbOk], 0);
end;

procedure TMDIBrett.Timer1Timer(Sender: TObject);
var iSec, iMove, iMax : Integer;
    iWert : Integer;

  function equal(inb : Integer) : Boolean;
  var i, j, k : Integer;
  begin
    Result := false;
    if inb < 1 then exit;
    if lEval.Count < inb then exit;
    i := lEval.Count - 1;
    j := 0;
    k := Integer(lEval[i]);
    while i > 0 do begin
      if k = Integer(lEval[i - 1]) then begin
        inc(j);
        if j >= inb then begin
          Result := true;
          exit;
        end;
      end
      else
        exit;
      dec(i);
    end;
  end;

begin
  if not sbPlay.Down then exit;
  if Brett1.WhitesTurn then
    iSec := trunc(tlWhite.MilliSecActual / 1000)
  else
    iSec := trunc(tlBlack.MilliSecActual / 1000);
  iMove := Notation1.GetNextMoveNumber;
  iWert := Round(MiniMax1.aktuellerWert * 100);
  lEval.Add(Pointer(iWert));
  iMax := trunc(iSec / 20);
  if (lEval.Count >= iMax) or (equal(10)) then
    MiniMax1.Stop := true;
end;

procedure TMDIBrett.tlBlackZue(Sender: TObject);
begin
  StopClocks;
  MiniMax1.Stop := true;
  MessageDlgLng(LOGetMess(LOZueBlack), mtInformation, [mbOk], 0);
end;

procedure TMDIBrett.Brett1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  deleteSquareMarker;
end;

procedure TMDIBrett.deleteSquareMarker;
begin
  if lastFromSquareMarked <> -1 then begin
    Brett1.refreshSquare(lastFromSquareMarked);
    lastFromSquareMarked := -1;
  end;
  if lastToSquareMarked <> -1 then begin
    Brett1.refreshSquare(lastToSquareMarked);
    lastToSquareMarked := -1;
  end;
end;

procedure TMDIBrett.lForderungClick(Sender: TObject);
begin
  pForderung.Visible := false;
end;

procedure TMDIBrett.tlBlackClick(Sender: TObject);
begin
  with TTimeDlg.Create(self) do try
    SpinEdit1.Value := MainForm.GameMin;
    SpinEdit2.Value := MainForm.MoveSec;
    if Showmodal = mrOk then begin
      tlBlack.SecTotal := SpinEdit1.Value * 60;
      tlBlack.SecPerMove := SpinEdit2.Value;
      MainForm.GameMin := SpinEdit1.Value;
      MainForm.MoveSec := SpinEdit2.Value;
      if not cbOnlyOneClock.Checked then begin
        tlWhite.SecTotal := SpinEdit1.Value * 60;
        tlWhite.SecPerMove := SpinEdit2.Value;
      end;
    end;
  finally
    free;
  end;
end;

procedure TMDIBrett.mZugzwangClick(Sender: TObject);
begin
  Notation1.SetInfAttr(infzugzwang);
end;

procedure TMDIBrett.Nichts2Click(Sender: TObject);
begin
  Notation1.SetInfAttr(0);
end;

procedure TMDIBrett.N3Click(Sender: TObject);
begin
  Notation1.SetInfAttr(infplusminus);
end;

procedure TMDIBrett.N11Click(Sender: TObject);
begin
  Notation1.SetInfAttr(infplusleichtminus);
end;

procedure TMDIBrett.N12Click(Sender: TObject);
begin
  Notation1.SetInfAttr(infplusgleich);
end;

procedure TMDIBrett.N13Click(Sender: TObject);
begin
  Notation1.SetInfAttr(infgleich);
end;

procedure TMDIBrett.oo1Click(Sender: TObject);
begin
  Notation1.SetInfAttr(infunklar);
end;

procedure TMDIBrett.N14Click(Sender: TObject);
begin
  Notation1.SetInfAttr(infgleichplus);
end;

procedure TMDIBrett.N15Click(Sender: TObject);
begin
  Notation1.SetInfAttr(infleichtminusplus);
end;

procedure TMDIBrett.N16Click(Sender: TObject);
begin
  Notation1.SetInfAttr(infminusplus);
end;

procedure TMDIBrett.mKompensationClick(Sender: TObject);
begin
  Notation1.SetInfAttr(infkompensation);
end;

procedure TMDIBrett.mGegenspielClick(Sender: TObject);
begin
  Notation1.SetInfAttr(infgegenspiel);
end;

procedure TMDIBrett.mInitiativeClick(Sender: TObject);
begin
  Notation1.SetInfAttr(infinitiative);
end;

procedure TMDIBrett.mAngriffClick(Sender: TObject);
begin
  Notation1.SetInfAttr(infangriff);
end;

procedure TMDIBrett.mZeitnotClick(Sender: TObject);
begin
  Notation1.SetInfAttr(infzeitnot);
end;

procedure TMDIBrett.mEntwicklungsvorsprungClick(Sender: TObject);
begin
  Notation1.SetInfAttr(infvorsprung);
end;

procedure TMDIBrett.mEinzigerZugClick(Sender: TObject);
begin
  Notation1.SetInfAttr(infeinzigerzug);
end;

procedure TMDIBrett.mNeuerungClick(Sender: TObject);
begin
  Notation1.SetInfAttr(infneuerung);
end;

procedure TMDIBrett.mMitderIdeeClick(Sender: TObject);
begin
  Notation1.SetInfAttr(infmitderidee);
end;

procedure TMDIBrett.mBesseristClick(Sender: TObject);
begin
  Notation1.SetInfAttr(infBesserIst);
end;

procedure TMDIBrett.Brett1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  deleteSquareMarker;
end;

procedure TMDIBrett.pBoardMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  deleteSquareMarker;
end;

end.
