unit PGNWin;

interface

uses Windows, Classes, Graphics, Forms, Controls, ComCtrls, StdCtrls, PGN,
     ExtCtrls, Buttons, SysUtils, Dialogs,
     SchachProcs, Spin, ShellApi, Notation, Brett, uReport, DialogsLng,
     ufrmMaterial, Menus, IniFiles;

type
  TMDIPGN = class(TForm)
    Panel1: TPanel;
    sbFilter: TSpeedButton;
    sbOpen: TSpeedButton;
    sbDeleteGame: TSpeedButton;
    sbDeleteDatabase: TSpeedButton;
    sbDragInsert: TSpeedButton;
    bPrint: TSpeedButton;
    hNotation: TNotation;
    bECO: TSpeedButton;
    bCompress: TSpeedButton;
    Panel2: TPanel;
    HeaderControl: THeaderControl;
    PGN1: TPGN;
    pFilter: TPanel;
    SearchBrett: TBrett;
    Label17: TLabel;
    Label19: TLabel;
    Label1: TLabel;
    lEco: TLabel;
    bFilter: TButton;
    eSpieler: TEdit;
    rbWeiss: TRadioButton;
    rbSchwarz: TRadioButton;
    rbBeide: TRadioButton;
    eEreignis: TEdit;
    cbZeitraum: TCheckBox;
    seAYear: TSpinEdit;
    seEYear: TSpinEdit;
    cbGewinn: TCheckBox;
    cbRemis: TCheckBox;
    cbVerlust: TCheckBox;
    bEmpty: TButton;
    cbPosition: TCheckBox;
    eECO: TEdit;
    cbMaterial: TCheckBox;
    PopupMenu1: TPopupMenu;
    HTMLkopieren1: TMenuItem;
    extkopieren1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PGN1PGNTrace(Sender: TObject; Percent: Integer;
      var CancelMode: TCancelMode);
    procedure HeaderControlSectionResize(HeaderControl: THeaderControl;
      Section: THeaderSection);
    procedure PGN1FilterRequest(Sender: TObject; GameHeader: TEventData;
      var ShowThisGame: Boolean);
    procedure bFilterClick(Sender: TObject);
    procedure PGN1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure sbFilterClick(Sender: TObject);
    procedure bEmptyClick(Sender: TObject);
    procedure PGN1BeforeCreatePGNFile(Sender: TObject; FileName: String;
      var CreateNewPGNFile: Boolean);
    procedure sbDeleteGameClick(Sender: TObject);
    procedure sbDeleteDatabaseClick(Sender: TObject);
    procedure PGN1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure PGN1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure bPrintClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure HeaderControlSectionClick(HeaderControl: THeaderControl;
      Section: THeaderSection);
    procedure FormShow(Sender: TObject);
    procedure bECOClick(Sender: TObject);
    procedure eSpielerKeyPress(Sender: TObject; var Key: Char);
    procedure PGN1PGNDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; GameHeader: TEventData; GameIndex: Integer);
    procedure PGN1PGNDblClick(Sender: TObject; PGNGame: String;
      GameID: Integer);
    procedure bCompressClick(Sender: TObject);
    procedure cbPositionClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbMaterialClick(Sender: TObject);
    procedure HTMLkopieren1Click(Sender: TObject);
    procedure extkopieren1Click(Sender: TObject);
  private
    FRC : PFischerInfo;
    searchPF : TPiecesFilter;
    procedure DisconnectOpenedGames;
    function AreBoardsOpen : Boolean;
    procedure hNotationFischerInfo(Sender: TObject; FischerInfo: TFischerInfo);

    // uncocumented start
    procedure docopy(html : Boolean);
    // uncocumented end

  public
    { Public declarations }
  end;

implementation

uses Main, ExploreWin, BrettWin, Local, LocalConst, uECO;

{$R *.DFM}

procedure TMDIPGN.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TMDIPGN.PGN1PGNTrace(Sender: TObject; Percent: Integer;
  var CancelMode: TCancelMode);
begin  {if CancelMode = cmCancel, the process is aborted (except of CancelMode = cmDenieded before)}
  MainForm.DoTrace(Sender, Percent, CancelMode);
end;

procedure TMDIPGN.HeaderControlSectionResize(HeaderControl: THeaderControl;
  Section: THeaderSection);
begin
  PGN1.Refresh;
end;

procedure TMDIPGN.PGN1FilterRequest(Sender: TObject;
  GameHeader: TEventData; var ShowThisGame: Boolean);
Var ok, w, b, g, r, v : Boolean;
    s : string;
    tmpBrett, suchBrett : TSchachbrett;
    tmpZug : TZug;
    i, j : word;
    pf : TPiecesFilter;
begin
  if not sbFilter.down then exit;
  with GameHeader do begin
    ok := true;
    if eSpieler.Text <> '' then begin
      s := uppercase(eSpieler.Text);
      if Pos(s, uppercase(Weiss)) <> 0 then w := true else w := false;
      if Pos(s, uppercase(Schwarz)) <> 0 then b := true else b := false;
      if rbWeiss.Checked then ok := w
      else if rbSchwarz.Checked then ok := b
      else ok := w or b;
    end;
    if (ok) and (trim(eEreignis.Text) <> '') then begin
      s := uppercase(trim(eEreignis.Text));
      ok := (Pos(s, uppercase(Quelle)) <> 0)
      or (Pos(s, uppercase(Ort)) <> 0)
      or (Pos(s, uppercase(Annotator)) <> 0)
    end;
    if (ok) and (trim(eECO.Text) <> '') then
      ok := Pos(uppercase(trim(eECO.Text)), uppercase(ECO)) <> 0;
    if (ok) and (cbZeitraum.Checked) then
      ok := (seAYear.Value <= Jahr) and (seEYear.Value >= Jahr);
    if ok then begin
      if (cbGewinn.Checked) or (cbRemis.Checked) or (cbVerlust.Checked) then begin
        if cbGewinn.Checked then g := Ergebnis = Gewinn else g := false;  {from the white "view point"}
        if cbRemis.Checked then r := Ergebnis = Remis else r := false;
        if cbVerlust.Checked then v := Ergebnis = Verlust else v := false;
        ok := g or r or v;
      end;
    end;
    if (ok) and
    ((cbPosition.Checked) or (cbMaterial.Checked)) then begin
      s := '';
      if FENString <> '' then s := #13#10 + '[FEN "' + FENString + '"]';
      hNotation.SetGame('[Event ""]' + s + #13#10#13#10 + tempData);
      pf := Nil;
      if cbMaterial.Checked then
        pf := searchPF;
      ok := hNotation.containsPos(pf, cbPosition.Checked);
    end;
  end;
  if not ok then ShowThisGame := false;
end;

procedure TMDIPGN.bFilterClick(Sender: TObject);
begin
  Enabled := false;
  Mainform.taggleAnalysis(true);
  try
    Mainform.log('Filtern');
    MainForm.Abbrechen := false;
    if cbPosition.Checked then
      hNotation.setcheckPosBoard(SearchBrett.GetBrStellung);
    if (trim(eSpieler.Text) = '')
    and (trim(eEreignis.Text) = '')
    and (trim(eECO.Text) = '')
    and (cbGewinn.Checked = false)
    and (cbRemis.Checked = false)
    and (cbVerlust.Checked = false)
    and (cbZeitraum.Checked = false)
    and (cbPosition.Checked = false)
    and (
      (cbMaterial.Checked = false)
      or (searchPF.isEmpty)
    )
    then
      PGN1.ccfFilterReset := true; //ccf
    PGN1.Filtern;
  finally
    Enabled := true;
    Mainform.taggleAnalysis(false);
  end;
end;

procedure TMDIPGN.PGN1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = 46 then sbDeleteGameClick(self);
end;

procedure TMDIPGN.sbFilterClick(Sender: TObject);
begin
  pFilter.Visible := sbFilter.Down;
end;

procedure TMDIPGN.bEmptyClick(Sender: TObject);
begin
  eSpieler.Text := '';
  rbBeide.Checked := true;
  eEreignis.Text := '';
  eECO.Text := '';
  cbZeitraum.Checked := false;
  cbGewinn.Checked := false;
  cbRemis.Checked := false;
  cbVerlust.Checked := false;
  cbPosition.Checked := false;
  cbMaterial.Checked := false;
end;

procedure TMDIPGN.PGN1BeforeCreatePGNFile(Sender: TObject;
  FileName: String; var CreateNewPGNFile: Boolean);
begin
  if MessageDlgLng(LOGetMess(LO_SolldiePGNDatei) + FileName + LOGetMess(LO_neuangelegtwerden),
  mtConfirmation, [mbYes, mbNo], 0) <> mrYes
    then CreateNewPGNFile := false;
end;

procedure TMDIPGN.sbDeleteGameClick(Sender: TObject);
Var i, ges, curr : longint;
    sl : TStringlist;
    c : TCancelMode;
    iq : TMsgDlgType;
    s : String;
begin
  if PGN1.SelCount <> 0 then begin
    iq := mtConfirmation;
    s := LOGetMess(LO_Wirklichloeschen);
    if not PGN1.isCCFFile then begin
      iq := mtWarning;
      s := LOGetMess(LO_Wirklichloeschen1);
    end;
    if MessageDlgLng(s, iq, [mbYes, mbNo], 0)
    = mrYes then begin
      Enabled := false; {deactivate the entire form while deleting (unlike while Filtern)}
      Screen.Cursor := crHourGlass;
      c := cmNoCancel;
      ges := PGN1.Selcount;
      curr := 0;
      MainForm.Abbrechen := false;
      PGN1.Items.BeginUpdate;
      sl := TStringlist.Create;
      PGN1.ccfFilesOpen := true;
      try
        for i := 0 to PGN1.Items.Count - 1 do   //ccf
          if PGN1.Selected[i] then
            sl.Add(IntToStr(i));
        i := sl.Count - 1;
        while i >= 0 do begin
          inc(curr);
          Mainform.lBackupHint.Visible := true;
          PGN1.DeleteGame(StrToInt(sl[i]));
          Mainform.log('Delete ' + sl[i]);
          Mainform.lBackupHint.Visible := false;
          MainForm.DoTrace(self, trunc(curr * 100 / ges), c);
          if c = cmCancel then Break;
          dec(i);
        end;
      finally
        PGN1.ccfFilesOpen := false;
        PGN1.Items.EndUpdate;
        MainForm.DoTrace(self, 0, c);
        Enabled := true;
        sl.Free;
        Screen.Cursor := crDefault;
      end;
    end;
  end;
end;

procedure TMDIPGN.sbDeleteDatabaseClick(Sender: TObject);
begin
  if MessageDlgLng(LOGetMess(LO_SolldiegesamteDatenbank), mtWarning, [mbYes, mbNo], 0) = mrYes then begin
    if PGN1.isCCFFile then begin   //ccf
      PGN1.ccfDeleteDatabase;
      Mainform.DeleteDatabase(Caption);
      Close;
    end
    else begin
      MainForm.DeletePGNFile := Caption;
      Close;
      PostMessage(MainForm.Handle, WM_DELETEPGNFILE, 0, 0);
    end;
  end;
end;

procedure TMDIPGN.PGN1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := Source is TPGN;
end;

procedure TMDIPGN.PGN1DragDrop(Sender, Source: TObject; X, Y: Integer);
Var ID, i, j, ges, curr : longint;
    s : string;
    p : TPoint;
    c : TCancelMode;  //ccf

  procedure setRawMode(pgn1, pgn2 : TPGN);
  begin
    if (pgn1.isCCFFile) and (pgn2.isCCFFile) then begin
      pgn1.ccfRaw := true;
      pgn2.ccfRaw := true;
    end;
    pgn1.ccfFilesOpen := true;
    pgn2.ccfFilesOpen := true;
  end;

  procedure delRawMode(pgn1, pgn2 : TPGN);
  begin
    pgn1.ccfRaw := false;
    pgn2.ccfRaw := false;
    pgn1.ccfFilesOpen := false;
    pgn2.ccfFilesOpen := false;
  end;

begin
Mainform.taggleAnalysis(true);
try
  if (Sender is TPGN) and (Source is TPGN) and (Sender <> Source) then begin
    if (Source as TPGN).SelCount = 0 then exit;
    ges := (Source as TPGN).SelCount;
    curr := 0;   //ccf
    Screen.Cursor := crHourGlass;
    enabled := false;
    getParentForm(Source as TPGN).Enabled := false;
    (Source as TPGN).Items.BeginUpdate;    {important!}
    (Sender as TPGN).Items.BeginUpdate;
    setRawMode(Source as TPGN, Sender as TPGN);
    try
      j := pgnAddGame;
      MainForm.Abbrechen := false;
      c := cmNoCancel;
      i := 0;
      while i < (Source as TPGN).Items.Count do begin
        if (Source as TPGN).Selected[i] then begin
          inc(curr);
          {Please note that the index of the listbox is not identical with the real index of the game in the database if the list is filtered}
          s := (Source as TPGN).GetGameAsString(
          (Source as TPGN).ListeIndexToDatabaseIndex(i), ID);
          if s <> '' then begin
            if sbDragInsert.Down then begin
              p.x := X;
              p.y := Y;
              j := (Sender as TPGN).ItemAtPos(p, true);  {-1 = no item -->  j = -1 = pgnAddGame}
            end
            else j := pgnAddGame;
            (Sender as TPGN).SaveGame(j, ID, s);
            {Inserts the game on the place j; if j = pgnAddGame on the last place
             (Parameter ID must not be saved here - only if the game could be changed later with ReplaceGame}
            (Source as TPGN).Selected[i] := false;
            MainForm.DoTrace(self, trunc(curr * 100 / ges), c);
            if c = cmCancel then Break;
          end;
        end;
        inc(i);
      end;
      if (j <> pgnAddGame) and (sbFilter.Down)
        then (Sender as TPGN).Filtern;
    finally
      delRawMode(Source as TPGN, Sender as TPGN);
      MainForm.DoTrace(self, 0, c);  // nicht spter ausfhren - Schutzverl.
      (Source as TPGN).Items.EndUpdate;
      (Sender as TPGN).Items.EndUpdate;
      getParentForm(Source as TPGN).Enabled := true;
      enabled := true;
      Screen.Cursor := crDefault;
    end;
  end;
finally
  Mainform.taggleAnalysis(false);
end;    
end;

procedure TMDIPGN.DisconnectOpenedGames;
Var I : Integer;
begin
  for I := MainForm.MDIChildCount - 1 downto 0 do
       if MainForm.MDIChildren[I] is TMDIBrett then begin
          if (MainForm.MDIChildren[I] as TMDIBrett).PGN = PGN1 then begin
           (MainForm.MDIChildren[I] as TMDIBrett).PGN := Nil;
           (MainForm.MDIChildren[I] as TMDIBrett).GameID := pgnAddGame;
           (MainForm.MDIChildren[I] as TMDIBrett).bPrev.Enabled := False;
           (MainForm.MDIChildren[I] as TMDIBrett).bNext.Enabled := False;
         end;
       end;
end;

function TMDIPGN.AreBoardsOpen : Boolean;
Var I : Integer;
    Opened : Boolean;
begin
  Opened := false;
  for I := MainForm.MDIChildCount - 1 downto 0 do
    if MainForm.MDIChildren[I] is TMDIBrett then
      if (MainForm.MDIChildren[I] as TMDIBrett).PGN = PGN1 then begin
         Opened := true;
         Break;
      end;
  Result := false;
  if Opened then
    if MessageDlgLng(LOGetMess(LO_AusdieserDatenbank), mtWarning, [mbYes, mbNo], 0) <> mrYes
      then Result := true;
end;

procedure TMDIPGN.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
Var I : Integer;
    Opened : Boolean;
begin
  if MainForm.Working then begin
    CanClose := false;
    exit;
  end;
  if MainForm.Closing then exit;
  if AreBoardsOpen then begin
    CanClose := false;
    exit;
  end;
  DisconnectOpenedGames;
  if WindowState = wsNormal then begin
    MainForm.PGNheight := Height;
    MainForm.PGNwidth := Width;
    MainForm.PGNTop := Top;
    MainForm.PGNLeft := Left;
  end;
end;

procedure TMDIPGN.bPrintClick(Sender: TObject);
Var ID : longint;
    i : longint;
    s : String;
begin
  s := '';
  For i := 0 to PGN1.Items.count - 1 do if PGN1.Selected[i] then
    s := s + PGN1.GetGameAsString(PGN1.ListeIndexToDatabaseIndex(i), ID) + noReturn + NoReturn;
  if s <> '' then
  with TfrmReport.Create(self) do try
    QRChessRichText1.FontHVar := Mainform.FontDialog1.Font;
    QRChessRichText1.FontHVar.Style := [fsBold];
    QRChessRichText1.Font1Var := Mainform.FontDialog1.Font;
    QRChessRichText1.Font1Var.Style := [];
    QRChessRichText1.Font2Var := Mainform.FontDialog1.Font;
    QRChessRichText1.Font2Var.Style := [fsItalic];
    QRChessRichText1.PGNGames := s;
    ChessReport.Preview;
  finally
    free;
  end;
end;

procedure TMDIPGN.FormCreate(Sender: TObject);
var year, month, day : Word;
begin
  if Mainform.PGNheight > 100 then Height := Mainform.PGNheight;
  if Mainform.PGNwidth > 100 then  Width :=  Mainform.PGNwidth;
  if (MainForm.PGNTop >= 0) and (MainForm.PGNTop + Height < Mainform.ClientHeight - Panel1.Height)
    then Top := MainForm.PGNTop
  else Top := 0;  
  if (MainForm.PGNLeft >= 0) and (MainForm.PGNLeft + Width < Mainform.ClientWidth)
    then Left := MainForm.PGNLeft
  else Left := 0;
  LOSavePGNWinStrings(self);
  New(FRC);
  searchPF := TPiecesFilter.Create;
  PGN1.ccfNotation := hNotation;
  hNotation.OnFischerInfo := hNotationFischerInfo;
  DecodeDate(Now, year, month, day);
  seAYear.Value := Year;
  seEYear.Value := Year;
  if Mainform.mToolbarBelow.Checked then
    Panel1.Align := alBottom;
end;

procedure TMDIPGN.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = 27 then Close;  
end;

procedure TMDIPGN.HeaderControlSectionClick(HeaderControl: THeaderControl;
  Section: THeaderSection);
begin
  enabled := false;
  Mainform.taggleAnalysis(true);
  try
    MainForm.Abbrechen := false;
    if Section = HeaderControl.Sections[0] then begin Mainform.log('sort 0'); PGN1.Sortieren(soNothing) end
    else if Section = HeaderControl.Sections[1] then begin Mainform.log('sort 1'); PGN1.Sortieren(soWeiss) end
    else if Section = HeaderControl.Sections[2] then begin Mainform.log('sort 2'); PGN1.Sortieren(soQuelle) end
    else if Section = HeaderControl.Sections[3] then begin Mainform.log('sort 3'); PGN1.Sortieren(soJahr) end
    else if Section = HeaderControl.Sections[4] then begin Mainform.log('sort 4'); PGN1.Sortieren(soErgebnis) end
    else begin Mainform.log('sort 5'); PGN1.Sortieren(soEco); end;
  finally
    enabled := true;
    Mainform.taggleAnalysis(false);
  end;   
end;

procedure TMDIPGN.FormShow(Sender: TObject);
begin
  if LO_lng <> LO_German then LOLoadPGNWinStrings(LO_lng, self);
end;

procedure TMDIPGN.bECOClick(Sender: TObject);
Var idummy : longint;
    i, iGes : longint;
    f : TextFile;
    s, sTemp, sPGN, sGame : string;
    frmEco : TfrmEco;
begin
  if MessageDlgLng(LOGetMess(LO_EcoZuordnen),  mtConfirmation, [mbYes, mbNo], 0) =
  mrYes then begin
    frmEco := TfrmEco.Create(self);
    self.enabled := false;
    try
      Screen.Cursor := crHourGlass;
      DisconnectOpenedGames;
      if not PGN1.isCCFFile then begin
        i := 0;
        sTemp := PGN1.PGNFile + IntToStr(i);
        while FileExists(s) and (i < 100) do begin
          inc(i);
          sTemp := PGN1.PGNFile + IntToStr(i);
        end;
        if i = 100 then exit;
        assignFile(f, sTemp);
        rewrite(f);
      end;
      MainForm.Abbrechen := false;
      iGes := PGN1.ItemsAllCount;
      For i := 0 to iGes - 1 do begin
        sGame := PGN1.GetGameAsString(i, idummy);
        sGame := frmEco.GetGameWithECO(sGame);
        if not PGN1.isCCFFile then
          writeln(f, sGame + #13#10#13#10)
        else
          PGN1.ReplaceGame(iDummy, sGame);
        MainForm.PrBar.Position := trunc(i * 50 / PGN1.ItemsAllCount);
        MainForm.DoProcessMessages;
        if MainForm.Abbrechen then Break;
      end;
      if not PGN1.isCCFFile then
        CloseFile(f);
      if MainForm.Abbrechen then begin
        if not PGN1.isCCFFile then
          DeleteFile(sTemp);
        MainForm.PrBar.Position := 0;
        exit;
      end;
      if not PGN1.isCCFFile then begin
        sPGN := PGN1.PGNFile;
        PGN1.PGNFile := '';
        if DeleteFile(sPGN) then
          RenameFile(sTemp, sPGN);
        PGN1.PGNFile := sPGN;
      end;
    finally
      self.enabled := true;
      frmEco.free;
      Screen.Cursor := crDefault;
      MainForm.PrBar.Position := 0;
    end;
  end;        
end;

procedure TMDIPGN.eSpielerKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then bFilterClick(Self);
end;

procedure TMDIPGN.PGN1PGNDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; GameHeader: TEventData; GameIndex: Integer);
Var s : string;
begin   {This event must ALWAYS have a handler if using TPGN}
  with (Control as TPGN).Canvas do begin
    FillRect(Rect);
    with GameHeader do begin
      if GameHeader.Deleted then
        Font.Style := Font.Style + [fsStrikeOut]
      else
        Font.Style := Font.Style - [fsStrikeOut];
      Rect.Right := HeaderControl.Sections[0].Width - 2;
      Font.Style := Font.Style - [fsBold];
      TextRect(Rect, Rect.Left + 5, Rect.Top, Format('%6d', [GameIndex + 1]));
      Rect.Left := Rect.Left + HeaderControl.Sections[0].Width;
      Rect.Right := Rect.Right + HeaderControl.Sections[1].Width - 2;
      Font.Style := Font.Style + [fsBold];
      TextRect(Rect, Rect.Left, Rect.Top, Weiss + ' - ' + Schwarz);
      Rect.Left := Rect.Left + HeaderControl.Sections[1].Width;
      Rect.Right := Rect.Right + HeaderControl.Sections[2].Width - 2;
      s := '';
      if (Quelle <> '') and (Quelle <> '?') then s := s + Quelle;
      if (Ort <> '') and (Ort <> '?') then begin
        if s <> '' then s := s + ', ';
        s := s + Ort;
      end;
      Font.Style := Font.Style - [fsBold];
      TextRect(Rect, Rect.Left, Rect.Top, s);
      Rect.Left := Rect.Left + HeaderControl.Sections[2].Width;
      Rect.Right := Rect.Right + HeaderControl.Sections[3].Width - 2;
      if Jahr <> 0 then s := IntTostr(Jahr) else s := '';
      TextRect(Rect, Rect.Left, Rect.Top, s);
      Rect.Left := Rect.Left + HeaderControl.Sections[3].Width;
      Rect.Right := Rect.Right + HeaderControl.Sections[4].Width - 2;
      Font.Style := Font.Style + [fsBold];
      if Ergebnis = '1/2-1/2' then
        TextRect(Rect, Rect.Left, Rect.Top, copy(Ergebnis, 1, 3))
      else
        TextRect(Rect, Rect.Left, Rect.Top, Ergebnis);
      Rect.Left := Rect.Left + HeaderControl.Sections[4].Width;
      Rect.Right := Rect.Right + HeaderControl.Sections[5].Width - 2;
      Font.Style := Font.Style - [fsBold];
      TextRect(Rect, Rect.Left, Rect.Top, Eco)
    end;
  end;
end;

procedure TMDIPGN.PGN1PGNDblClick(Sender: TObject; PGNGame: String;
  GameID: Integer);
begin {This event is triggered after <ENTER>, also}
  MainForm.log('Open ' + IntToStr(PGN1.ItemIndex));
  MainForm.CreateMDIBrettChild(PGN1, PGNGame, GameID, false);
end;

procedure TMDIPGN.bCompressClick(Sender: TObject);
var s : String;
begin
  if MessageDlgLng(LOGetMess(LOCompress), mtConfirmation, mbYesNoCancel, 0)
    <> mrYes then exit;
  if AreBoardsOpen then
    exit;
  DisconnectOpenedGames;
  self.enabled := false; //ccf
  try
    MainForm.Abbrechen := false;
    if PGN1.ccfCompress then begin
      s := PGN1.PGNFile;
      PGN1.PGNFile := '';
      PGN1.PGNFile := s;
    end;
  finally
    self.enabled := true;  
  end;
end;

procedure TMDIPGN.cbPositionClick(Sender: TObject);
begin
  if cbPosition.Checked then SearchBrett.Aufbauen(true)  {true = an illegal position is not refused}
end;

procedure TMDIPGN.FormDestroy(Sender: TObject);
begin
  Dispose(FRC);
  searchPF.Free;
end;

procedure TMDIPGN.hNotationFischerInfo(Sender: TObject;
  FischerInfo: TFischerInfo);
begin
  if Fischerinfo.Enabled then begin  {triggered, when TNotation just loaded a Fischer-Random-Game}
    FRC^ := Fischerinfo;
    hNotation.FRC := FRC;
  end
  else
    hNotation.FRC := Nil;
end;
                                         

procedure TMDIPGN.cbMaterialClick(Sender: TObject);
begin
  if cbMaterial.Checked then begin
    with TfrmMaterial.Create(self) do try
      sewQa.Value := searchPF.min[wD]; cbwQ.Checked := searchPF.checkPiece[wD];
      sewRa.Value := searchPF.min[wT]; cbwR.Checked := searchPF.checkPiece[wT];
      sewBa.Value := searchPF.min[wL]; cbwB.Checked := searchPF.checkPiece[wL];
      sewNa.Value := searchPF.min[wS]; cbwN.Checked := searchPF.checkPiece[wS];
      sewPa.Value := searchPF.min[wB]; cbwP.Checked := searchPF.checkPiece[wB];
      sewQe.Value := searchPF.max[wD];
      sewRe.Value := searchPF.max[wT];
      sewBe.Value := searchPF.max[wL];
      sewNe.Value := searchPF.max[wS];
      sewPe.Value := searchPF.max[wB];

      sebQa.Value := searchPF.min[sD]; cbbQ.Checked := searchPF.checkPiece[sD];
      sebRa.Value := searchPF.min[sT]; cbbR.Checked := searchPF.checkPiece[sT];
      sebBa.Value := searchPF.min[sL]; cbbB.Checked := searchPF.checkPiece[sL];
      sebNa.Value := searchPF.min[sS]; cbbN.Checked := searchPF.checkPiece[sS];
      sebPa.Value := searchPF.min[sB]; cbbP.Checked := searchPF.checkPiece[sB];
      sebQe.Value := searchPF.max[sD];
      sebRe.Value := searchPF.max[sT]; 
      sebBe.Value := searchPF.max[sL]; 
      sebNe.Value := searchPF.max[sS]; 
      sebPe.Value := searchPF.max[sB];
      if ShowModal = mrOk then begin
        searchPF.min[wD] := sewQa.Value;  searchPF.checkPiece[wD] := cbwQ.Checked;
        searchPF.min[wT] := sewRa.Value;  searchPF.checkPiece[wT] := cbwR.Checked;
        searchPF.min[wL] := sewBa.Value;  searchPF.checkPiece[wL] := cbwB.Checked;
        searchPF.min[wS] := sewNa.Value;  searchPF.checkPiece[wS] := cbwN.Checked;
        searchPF.min[wB] := sewPa.Value;  searchPF.checkPiece[wB] := cbwP.Checked;
        searchPF.max[wD] := sewQe.Value;
        searchPF.max[wT] := sewRe.Value;
        searchPF.max[wL] := sewBe.Value;
        searchPF.max[wS] := sewNe.Value;
        searchPF.max[wB] := sewPe.Value;

        searchPF.min[sD] := sebQa.Value; searchPF.checkPiece[sD] := cbbQ.Checked;
        searchPF.min[sT] := sebRa.Value; searchPF.checkPiece[sT] := cbbR.Checked;
        searchPF.min[sL] := sebBa.Value; searchPF.checkPiece[sL] := cbbB.Checked;
        searchPF.min[sS] := sebNa.Value; searchPF.checkPiece[sS] := cbbN.Checked;
        searchPF.min[sB] := sebPa.Value; searchPF.checkPiece[sB] := cbbP.Checked;
        searchPF.max[sD] := sebQe.Value;
        searchPF.max[sT] := sebRe.Value;
        searchPF.max[sL] := sebBe.Value;
        searchPF.max[sS] := sebNe.Value;
        searchPF.max[sB] := sebPe.Value;
      end;
    finally
      Free;
    end;
  end;
end;

// uncocumented start

procedure TMDIPGN.HTMLkopieren1Click(Sender: TObject);
begin
  docopy(true);
end;

procedure TMDIPGN.extkopieren1Click(Sender: TObject);
begin
  docopy(false);
end;

procedure TMDIPGN.docopy(html : Boolean);
var i, j, dummy, round : Integer;
    a : array[0..50] of TStringlist;
    s, s1, s5, space : String;
    memo : TMemo;
    ev : PEventData;
begin
  space := ' ';
  with TIniFile.Create(ExtractFilePath(Application.ExeName) + sIniFileName) do try
    s5 := ReadString(sOptions, 'remis', '1/2');
  finally
    free;
  end;
  memo := TMemo.Create(self);
  memo.Visible := false;
  memo.Parent := self;
  for i := 0 to 50 do begin
    a[i] := TStringlist.Create;
    a[i].Sorted := true;
    a[i].Duplicates := dupAccept;
  end;
  try
  for i := 0 to PGN1.ItemsVisibleCount - 1 do   //ccf
  if (PGN1.SelCount < 2) or (PGN1.Selected[i]) then begin
    s := PGN1.GetGameAsString(i, dummy);
    if s <> '' then begin
      hNotation.SetGame(s);
      round := hNotation.Partiedaten.EventData.Runde;
      if round < 51 then begin
        New(ev);
        ev^ := hNotation.Partiedaten.EventData;
        a[round].AddObject(IntToStr(ev^.WElo + ev^.SElo), Pointer(ev));
      end;
    end;
  end;
  s := '';
  for i := 0 to 50 do if a[i].Count <> 0 then begin
    if i <> 0 then begin
      if html then s := s + '<b>';
      s := s + 'Runde ' + IntToStr(i);
      if not html then s := s + #13#10#13#10
      else s := s + '</b><br><table>';
    end;
    For j := a[i].Count - 1 downto 0 do begin
      if html then s := s + '<tr><td>';
      ev := PEventData(a[i].Objects[j]);
      s := s + ev.Weiss;
      if not html then s := s + space
      else s := s + '</td><td>';
      if ev.WElo > 0 then s := s + IntToStr(ev.WElo)
      else s := s + ' ';
      if not html then s := s + space + '-' + space
      else s := s + '</td><td>-</td><td>';
      s := s + ev.Schwarz;
      if not html then s := s + space
      else s := s + '</td><td>';
      if ev.SElo > 0 then s := s + IntToStr(ev.SElo)
      else s := s + ' ';
      if not html then s := s + space
      else s := s + '</td><td>';
      s1 := ev.ergebnis;
      if s1 = '1/2-1/2' then s1 := s5
      else if s1 = '*' then s1 := ' ';
      s := s + s1;
      if not html then s := s + #13#10
      else if html then s := s + '</td></tr>';
    end;
    if (i < 50) and (a[i + 1] <> Nil) then
      if not html then s := s + #13#10
      else s := s + '</table><br>';
  end;
  memo.Text := s;
  memo.SelStart := 0;
  memo.SelLength := length(memo.Text);
  memo.CopyToClipboard;
  finally
    for i := 0 to 50 do begin
      while a[i].Count > 0 do begin
        Dispose(PEventData(a[i].Objects[0]));
        a[i].Delete(0);
      end;
      a[i].Free;
    end;
    memo.Free;
  end;
end;

// uncocumented end

end.
