unit About;

interface

uses Windows, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ShellApi, Brett;

Const sHome = 'http://www.mailchess.de/delphi.html';
      sFischer = 'http://www.mailchess.de/linkto/fischer_rules.html';
      sFont = 'http://www.mailchess.de/linkto/font_1echecs.html';
      sGnu = 'http://www.mailchess.de/linkto/gnu_gpl.html';
      sFontNT = 'http://www.mailchess.de/linkto/font_merida.html';

type
  TAboutBox = class(TForm)
    Panel1: TPanel;
    OKButton: TButton;
    ProgramIcon: TImage;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    lFischer: TLabel;
    lDelphi: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lFont: TLabel;
    Label1: TLabel;
    lGnu: TLabel;
    Label5: TLabel;
    Bevel1: TBevel;
    Label4: TLabel;
    lFontNT: TLabel;
    lFontInfo: TLabel;
    Label6: TLabel;
    procedure lDelphiClick(Sender: TObject);
    procedure lFischerClick(Sender: TObject);
    procedure lFontClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lGnuClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure lFontNTClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AboutBox: TAboutBox;

implementation

uses Main, Local;

{$R *.DFM}


procedure TAboutBox.lDelphiClick(Sender: TObject);
begin
  ShellExecute(Handle, 'open', sHome, '','', SW_SHOWNORMAL);
end;

procedure TAboutBox.lFischerClick(Sender: TObject);
begin
  ShellExecute(Handle, 'open', sFischer, '','', SW_SHOWNORMAL);
end;

procedure TAboutBox.lFontClick(Sender: TObject);
begin
  ShellExecute(Handle, 'open', sFont, '','', SW_SHOWNORMAL);
end;

procedure TAboutBox.FormCreate(Sender: TObject);
begin
  lDelphi.Hint := '|' + sHome;
  lFischer.Hint := '|' + sFischer;
  lFont.Hint := '|' + sFont;
  lFontNT.Hint := '|' + sFontNT;
  lGnu.Hint := '|' + sGnu;
end;

procedure TAboutBox.lGnuClick(Sender: TObject);
begin
  ShellExecute(Handle, 'open', sGnu, '','', SW_SHOWNORMAL);
end;

procedure TAboutBox.FormShow(Sender: TObject);
begin
  if LO_lng <> LO_German then LOLoadAboutWinStrings(LO_lng, self);
end;

procedure TAboutBox.lFontNTClick(Sender: TObject);
begin
  ShellExecute(Handle, 'open', sFontNT, '','', SW_SHOWNORMAL);
end;

procedure TAboutBox.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = 27 then ModalResult := mrCancel;
end;

end.

