unit cProtokoll;

(*
This unit only writes a log.
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls;

const maxLength = 2000000;
      maxBufferedLines = 50;

type
     TProtokoll = class(TObject)
       constructor Create(aFileName : String);
       destructor Destroy; override;
       private
         slProt : TStringlist;
         FileName : string;
         FLogDisabled : Boolean;
         FBufferedLines : Integer;
         FmaxSize : Integer;
         procedure setmaxSize(i : Integer);
         function  getDate : String;
         function  log(sLine : String) : Boolean;
         procedure backup;
         function  doWrite : Boolean;
       public
         property LogDisabled : Boolean read FLogDisabled write FLogDisabled;
         property BufferedLines : Integer read FBufferedLines write FBufferedLines;
         property maxSize : Integer read FmaxSize write setmaxSize;
         function writeErr(s : String) : Boolean;
         function writeOut(s : String) : Boolean;
         procedure flush;
     end;

Var Prot : TProtokoll;

implementation

constructor TProtokoll.Create(aFileName : String);
begin
  inherited create;
  FileName := aFileName;
  FBufferedLines := maxBufferedLines;
  FmaxSize := maxLength;
  slProt := TStringlist.Create;
end;

destructor TProtokoll.Destroy;
begin
  Flush;
  slProt.Free;
  inherited destroy;
end;

procedure TProtokoll.setmaxSize(i : Integer);
begin
  if i > 100000 then FmaxSize := i;
end;

procedure TProtokoll.flush;
begin
  doWrite;
end;

function TProtokoll.getDate : String;
begin
  Result := '';
  try
    Result := DateTimeToStr(Now) + ': ';
  except
  end;
end;

procedure TProtokoll.backup;
Var f: file of Byte;
    size : Integer;

function  StreamKopie(von, nach : string) : integer;
var f1, f2 : THandleStream;
    fvon, fnach : THandle;
    i : integer;
begin
  Result := -1;
  if not FileExists(von) then exit;
  try
    Fvon := FileOpen(von, fmOpenRead);
    if Fvon > 0 then try
      i := FileGetDate(fvon);
      FNach := FileCreate(Nach);
      if FNach > 0 then try
        f1 := THandleStream.Create(Fvon);
        try
          f2 := THandleStream.Create(Fnach);
          try
            f2.CopyFrom(f1, f1.Size);
            Result := 0;
          finally
            f2.Free;
          end;
        finally
          f1.Free;
        end;
        FileSetDate(fNach, i);
      finally
        FileClose(fNach);
      end;
    finally
      FileClose(fvon);
    end;
  except
  end;
end;


begin
  try
    AssignFile(f, FileName);
    Reset(f);
    size := FileSize(f);
    closeFile(f);
    if size > maxLength then begin
      StreamKopie(FileName, FileName + '.old');
      DeleteFile(FileName);
    end;
  except
  end;
end;

function TProtokoll.doWrite : Boolean;
var i : Integer;
    f : TextFile;
begin
  Result := false;
  try
    assignFile(f, FileName);
    if FileExists(FileName) then append(f)
    else rewrite(f);
    try
      for i := 0 to slProt.Count - 1 do
        writeln(f, slProt[i]);
    finally
      closeFile(f);
      slProt.Clear;
    end;
    Result := true;
  except;
  end;
end;

function TProtokoll.log(sLine : string) : Boolean;
var s : String;
begin
  Result := false;
  try
    if LogDisabled then exit;
    slProt.Add(sLine);
    if slProt.Count > FBufferedLines then begin
      backup;
      Result := doWrite;
    end
    else Result := true;
  except
  end;
end;

function TProtokoll.writeErr(s : String) : Boolean;
begin
  Result := log('ERROR:' + getDate + s);
end;

function TProtokoll.writeOut(s : String) : Boolean;
begin
  Result := log('OUT:  ' + getDate + s);
end;

end.
