//!!! vor Erstellen von CompoChess Data.res (inf.font) einbinden!
unit Main;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, DialogsLng, Buttons, Messages, ExtCtrls, ComCtrls,
  SchachProcs,   { This unit must always be embedded if one of the chess components is used}
  Brett, PGN, IniFiles, MiniMax, Dialogs, Registry, ChessDatabase,
  PGNWin, cProtokoll, ImgList, ActiveX, ComObj, ShlObj, ShellAPI, FileCtrl,
  DdeMan;

const WM_DELETEPGNFILE = WM_USER + 5;
      WM_LOADFILE      = WM_USER + 4;
      WM_RESPONSE      = WM_USER + 3;

var   WM_APPRUNNING : cardinal;
      PrevInst      : boolean;

const sHistory = 'History';
      sOptions = 'Options';
      sEngine = 'Engine';
      sEngineNames = 'WBEngines';

      ret = #13#10; 
      BUFSIZE = 1024;
      WBCraftyParam = 'log=off hash=1000000';  // keine log-Datei 768kB Hash
      WBCraftyIni   = 'xboard' + ret + 'post' + ret + 'force' + ret;
      WbCraftySetBoard = 'setboard';  // ' ' + Stellung + ret wird beim Aufruf angefgt
      WbCraftyStartAnalyze  = 'post' + ret + 'analyze' + ret;
      WbCraftyStopAnalyze = 'exit' + ret;
      WbCraftyQuit        = 'quit' + ret;
      WbCraftyGetState    = '.' + ret;

      InfFontName = 'Courier New Chess';
      InfFontFilenameWithoutExt = 'courchess';
      InfFontFilename = 'courchess.ttf';
      maxHist = 16;

      sCompoChess = 'CompoChess';
      sCompoChessExt = '.ccf';

      sLogFile = 'cclogfile.txt';
      sEnglishFile = 'English.lng';
      sIniFileName = 'CompoChess.ini';
      uninstallbatfile = 'remove_compochess.bat';

type
  TWBInfo = record
    hProcess : THANDLE;
    pid: DWORD ;
    hTo: THANDLE ;
    hFrom: THANDLE ;

    WBParam, WBIni,
    WbSetBoard, WbStartAnalyze,
    WbStopAnalyze, WbQuit,
    WbGetState : string;
    WbNoParseOutput : Boolean;

    CraftyFile : string;
  end ;

  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    mGameOpen: TMenuItem;
    mClose: TMenuItem;
    Window1: TMenuItem;
    mExit: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    OpenDialog: TOpenDialog;
    WindowMinimizeItem: TMenuItem;
    Panel1: TPanel;
    pHint: TPanel;
    pTrace: TPanel;
    prBar: TProgressBar;
    bStop: TBitBtn;
    hBrett: TBrett;
    mHistory: TMenuItem;
    FontDialog1: TFontDialog;
    FontDialogComm: TFontDialog;
    mOptions: TMenuItem;
    mShowLastMove: TMenuItem;
    mAnimation: TMenuItem;
    mClickClick: TMenuItem;
    mSprache: TMenuItem;
    N1: TMenuItem;
    mBlackSquare: TMenuItem;
    mWhiteSquare: TMenuItem;
    ColorDialog1: TColorDialog;
    mFont: TMenuItem;
    mFontComm: TMenuItem;
    Engines1: TMenuItem;
    mFontPrint: TMenuItem;
    m1Echecs: TMenuItem;
    mChessMerida: TMenuItem;
    mAssignPGN: TMenuItem;
    N5: TMenuItem;
    mNewFRC: TMenuItem;
    mNextWin: TMenuItem;
    lBackuphint: TLabel;
    N3: TMenuItem;
    mKombis: TMenuItem;
    BeliebigesThema1: TMenuItem;
    N6: TMenuItem;
    BeseitigungderVerteidigung1: TMenuItem;
    Ablenkung1: TMenuItem;
    Hinlenkung1: TMenuItem;
    Rumung1: TMenuItem;
    Fesselung1: TMenuItem;
    Unterbrechung1: TMenuItem;
    Bauernumwandlung1: TMenuItem;
    Remiskombinationen1: TMenuItem;
    Verschiedenes1: TMenuItem;
    BeliebigeSchwierigkeit1: TMenuItem;
    N7: TMenuItem;
    Leicht1: TMenuItem;
    Mittel1: TMenuItem;
    Schwer1: TMenuItem;
    BeliebigeSchwierigkeit2: TMenuItem;
    N8: TMenuItem;
    Leicht2: TMenuItem;
    Mittel2: TMenuItem;
    Schwer2: TMenuItem;
    BeliebigeSchwierigkeit3: TMenuItem;
    N9: TMenuItem;
    Leicht3: TMenuItem;
    Mittel3: TMenuItem;
    Schwer3: TMenuItem;
    BeliebigeSchwierigkeit4: TMenuItem;
    N10: TMenuItem;
    Leicht4: TMenuItem;
    Mittel4: TMenuItem;
    Schwer4: TMenuItem;
    BeliebigeSchwierigkeit5: TMenuItem;
    N11: TMenuItem;
    Leicht5: TMenuItem;
    Mittel5: TMenuItem;
    Schwer5: TMenuItem;
    BeliebigeSchwierigkeit6: TMenuItem;
    N12: TMenuItem;
    Leicht6: TMenuItem;
    Mittel6: TMenuItem;
    Schwer6: TMenuItem;
    BeliebigeSchwierigkeit7: TMenuItem;
    N13: TMenuItem;
    Leicht7: TMenuItem;
    Mittel7: TMenuItem;
    Schwer7: TMenuItem;
    BeliebigeSchwierigkeit8: TMenuItem;
    N14: TMenuItem;
    Leicht8: TMenuItem;
    Mittel8: TMenuItem;
    Schwer8: TMenuItem;
    BeliebigeSchwierigkeit9: TMenuItem;
    N15: TMenuItem;
    Leicht9: TMenuItem;
    Mittel9: TMenuItem;
    Schwer9: TMenuItem;
    BeliebigeSchwierigkeit10: TMenuItem;
    N16: TMenuItem;
    Leicht10: TMenuItem;
    Mittel10: TMenuItem;
    Schwer10: TMenuItem;
    tacticPGN: TPGN;
    mToolbarBelow: TMenuItem;
    ImageList1: TImageList;
    mOtherLang: TMenuItem;
    N2: TMenuItem;
    mUninstall: TMenuItem;
    DdeClient: TDdeClientConv;
    procedure FormCreate(Sender: TObject);
    procedure WindowCascadeItemClick(Sender: TObject);
    procedure UpdateMenuItems(Sender: TObject);
    procedure WindowTileItemClick(Sender: TObject);
    procedure WindowArrangeItemClick(Sender: TObject);
    procedure mCloseClick(Sender: TObject);
    procedure WindowMinimizeItemClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure HelpAboutItemClick(Sender: TObject);
    procedure bStopClick(Sender: TObject);
    procedure mExitClick(Sender: TObject);
    procedure mGameOpenClick(Sender: TObject);
    procedure mHistoryClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure mShowLastMoveClick(Sender: TObject);
    procedure mAnimationClick(Sender: TObject);
    procedure mClickClickClick(Sender: TObject);
    procedure mBlackSquareClick(Sender: TObject);
    procedure mWhiteSquareClick(Sender: TObject);
    procedure mFontCommClick(Sender: TObject);
    procedure mFontClick(Sender: TObject);
    procedure Engines1Click(Sender: TObject);
    procedure m1EchecsClick(Sender: TObject);
    procedure mChessMeridaClick(Sender: TObject);
    procedure mAssignPGNClick(Sender: TObject);
    procedure mNewFRCClick(Sender: TObject);
    procedure mNextWinClick(Sender: TObject);
    procedure BeliebigeSchwierigkeit1Click(Sender: TObject);
    procedure tacticPGNFilterRequest(Sender: TObject;
      GameHeader: TEventData; var ShowThisGame: Boolean);
    procedure mToolbarBelowClick(Sender: TObject);
    procedure mOtherLangClick(Sender: TObject);
    procedure mUninstallClick(Sender: TObject);
  private
    { Private declarations }
    slDatabase : TStringList;
    verzeichnis, otherLang : string;
    f1, f2 : String;
    DatabaseWinEnabled : Boolean;
    Prot : TProtokoll;
    doNotWriteIni : Boolean;
    procedure ShowHint(Sender: TObject);
    procedure DoDeletePGNFile(Var Msg : TMsg); message WM_DELETEPGNFILE;
    procedure LoadFile(Var Msg : TMsg); message WM_LOADFILE;
    procedure DoClose(Var Msg : TMsg); message WM_CLOSE;
    procedure HandleLang(Sender : TObject);
    procedure SetLang(s : string);
    function  isBrettOpened : TForm;
    procedure LookForBackup(sFilename : String);
    procedure assignExt(sName, sExt, Exename : String);
    procedure GetFontNames;
  public
    { Public declarations }
    DatabaseWinOpen, Working, Closing : Boolean;
    DeletePGNFile, SaveDataBase : string;
    Abbrechen : Boolean;
    Brettheight, Brettwidth, BrettTop, BrettLeft, BrettSize,
    PGNheight, PGNwidth, PGNTop, PGNLeft,
    Databaseheight, Databasewidth, MainTop, MainLeft, MainHeight, MainWidth : integer;
    BrettState : TWindowState;
    BlackSquare, WhiteSquare : TColor;
    WhiteOnTop : Boolean;
    figK, figQ, figR, figB, figN, figP : string;
    InformantSigns : String;
    WBInfo : TWBInfo;
    slEngines : TStringList;
    UserdefinedEngineParam : Boolean;
    GameMin, MoveSec : Integer;
    lf : TList;
    InfFontInstalled : Boolean;
    DatabaseFolder : String;
    procedure CreateMDIPGNChild(const Name: string);
    procedure DoTrace(Sender: TObject; Percent: Integer; var CancelMode: TCancelMode);
    procedure AddDatabase(s : string);
    procedure DeleteDatabase(s : string);
    procedure CreateMDIBrettChild(const PGN : TPGN; Game : string; GameID : longint; FischerChess : Boolean);
    procedure DoProcessMessages;
    procedure setWBDefaults;
    procedure setPGNWinButtons(Child : TMDIPGN);
    procedure log(s : String);
    procedure logerr(s : String);
    procedure taggleAnalysis(stop : Boolean);
  end;

var
  MainForm: TMainForm;

function  DatabaseNameToListboxName(s : string) : string;
function  ListboxNameToDatabaseName(s : string) : string;
function  getParentForm(c : TControl) : TForm;

implementation

{$R *.DFM}
{$R Data.res}

uses BrettWin, ExploreWin, About, Local, LocalConst, uPieces,
     ufrmEngines;

function  getParentForm(c : TControl) : TForm;
var o : TObject;
begin
  Result := Nil;
  o := c;
  while true do begin
    if o is TForm then begin
      Result := TForm(o);
      exit;
    end;
    o := TControl(o).Parent;
  end;
end;

function EnumFontsProc(var LogFont: TLogFont; var TextMetric: TTextMetric;
  FontType: Integer; Data: Pointer): Integer; stdcall;
begin
  if Pos(InfFontName, LogFont.lfFaceName) = 1 then
    TMainform(Data).InfFontInstalled := true;
  Result := 1;
end;

procedure TMainForm.GetFontNames;
var
  DC: HDC;
begin
  try
    DC := GetDC(0);
    EnumFonts(DC, nil, @EnumFontsProc, Pointer(self));
    ReleaseDC(0, DC);
  except
  end;
end;

function TMainForm.isBrettOpened : TForm;
Var I : Integer;
begin
  Result := Nil;
  for I := MDIChildCount - 1 downto 0 do if MDIChildren[I] is TMDIBrett
  then begin
    Result := MDIChildren[I];
    break;
  end;
end;

(*
If a database is open, it would check whether games are opened from there.
Closing = true avoids this check
*)
procedure TMainForm.DoClose(Var Msg : TMsg);
begin
  Closing := True;
  Close;
  Closing := False;
end;

procedure TMainForm.DoDeletePGNFile(Var Msg : TMsg);
begin
  DeleteFile(DeletePGNFile);
  DeleteDatabase(DeletePGNFile);
  DeletePGNFile := '';
end;

procedure TMainForm.DoProcessMessages;
begin
  Working := true;
  Application.ProcessMessages;
  Working := false;
end;

procedure TMainForm.DoTrace(Sender: TObject; Percent: Integer; var CancelMode: TCancelMode);
begin
  if Percent = -1 then begin
    lBackupHint.Visible := false;
    PrBar.Position := 0;
  end
  else PrBar.Position := Percent;
  if CancelMode <> cmCancelDenied then begin
    DoProcessMessages;
    if Abbrechen then CancelMode := cmCancel;
  end
  else if Percent = 0 then Refresh;
end;

function DatabaseNameToListboxName(s : string) : string;
begin
  Result := ExtractFileName(s) + '   "' + s + '"';
end;

function ListboxNameToDatabaseName(s : string) : string;
Var i : integer;
begin
  Result := '';
  i := Pos('"', s);
  if i = 0 then exit;
  Result := copy(s, i + 1, length(s));
  if Result <> '' then delete(Result, length(Result), 1);
end;

procedure TMainForm.DeleteDatabase(s : string);
Var i : integer;
begin
  i := slDatabase.IndexOf(DatabaseNameToListboxName(s));
  if i <> -1 then begin
    slDatabase.Delete(i);
    if MDIDatabase <> Nil then
      MDIDatabase.lbDatabase.Items.Assign(slDataBase);
  end;
end;

procedure TMainForm.AddDatabase(s : string);
begin
  if (s = '') or
  (slDatabase.IndexOf(DatabaseNameToListboxName(s)) <> -1)
    then exit;
  slDatabase.Insert(0, DatabaseNameToListboxName(s));
  if slDatabase.Count > maxHist then slDatabase.Delete(slDatabase.Count - 1);
  if MDIDatabase <> Nil then
    MDIDatabase.lbDatabase.Items.Assign(slDataBase);
end;

procedure TMainForm.setPGNWinButtons(Child : TMDIPGN);
begin
  if Child.PGN1.isCCFFile then begin
    Child.sbDragInsert.Enabled := false;
    Child.bCompress.Enabled := true;
  end
  else begin
    Child.sbDragInsert.Enabled := true;
    Child.bCompress.Enabled := false;
    LookForBackup(Child.Caption);
  end;
end;

procedure TMainForm.CreateMDIPGNChild(const Name: string);
var I : Integer;
    Child: TMDIPGN;
begin
Mainform.taggleAnalysis(true);
try
  for I := MDIChildCount - 1 downto 0 do
    if uppercase(MDIChildren[I].Caption) = uppercase(Name) then begin
      MDIChildren[I].BringToFront;
      exit;
    end;
  Child := TMDIPGN.Create(Application);
  if Child.Top + Child.Height + 2 > ClientHeight then  //ccf
    Child.Top := 0;
  if Child.Left + Child.Width + 2 > ClientWidth then
    Child.Left := 0;
  Abbrechen := false;
  Child.PGN1.PGNFile := Name;
  Child.Caption := Child.PGN1.PGNFile;
  AddDatabase(Child.PGN1.PGNFile);
  Child.Panel1.Enabled := true;
  if Child.PGN1.PGNFile = '' then Child.Close
  else
    setPGNWinButtons(Child); //ccf
finally
  Mainform.taggleAnalysis(false);
end;      
end;

procedure TMainForm.LookForBackup(sFilename : String);
var SearchRec : TSearchRec;
    sl : TStringlist;
    i : Integer;
    s, spath, sFound : String;
begin
  try
    sl := TStringlist.Create;
    try
      s := uppercase(ExtractFileName(sFilename));
      spath := ExtractFilePath(sFilename);
      if FindFirst(spath + '*.pgn' , faAnyFile, SearchRec) = 0 then begin
        repeat
          if uppercase(SearchRec.Name) <> s then
            sl.Add(SearchRec.Name);
        until FindNext(SearchRec) <> 0;
        FindClose(SearchRec);
      end;
      sFound := '';
      for i := 0 to sl.Count - 1 do
        if (Pos(s , uppercase(sl[i])) <> 0) and
        (Pos('BACKUP' , uppercase(sl[i])) = 1) then begin
          sFound := sl[i];
          insert('_', sFound, length(sFound) - 3);
          RenameFile(spath + sl[i], spath + sFound);
          MessageDlgLng(Format(LOGetMess(LOsavenotfinished), [spath + sFound]), mtWarning, [mbOk], 0);
          AddDatabase(spath + sFound);
          break;
        end;
    finally
      sl.Free;
    end;
  except
  end;
end;

procedure TMainForm.CreateMDIBrettChild(const PGN : TPGN; Game : string; GameID : longint; FischerChess : Boolean);
var I : Integer;
    Child: TMDIBrett;

begin
  Screen.Cursor := crHourGlass;
  try
    if Game <> '' then for I := MDIChildCount - 1 downto 0 do
      if MDIChildren[I] is TMDIBrett then
        if ((MDIChildren[I] as TMDIBrett).PGN = PGN) and
        ((MDIChildren[I] as TMDIBrett).GameID = GameID) then begin
          MDIChildren[I].BringToFront;
          exit;
        end;
    Child := TMDIBrett.Create(Application);
    Child.setEngineMenu;
    Child.Brett1.LockBoardUpdate := true;
    try
      Child.PGN := PGN;
      Child.GameID := GameID;
      if Game <> '' then begin
        Child.Notation1.SetGame(Game);
        Child.bPrev.Enabled := true;
        Child.bNext.Enabled := true;
      end
      else if {MainForm.mFRCx.Checked}FischerChess then begin
        Child.Brett1.SetPosition(GetFischerRandomPosition, Child.Brett1.GetBrZug);
        SetFischerInfo(Child.FRC, Child.Brett1.GetBrStellung);
        Child.Notation1.NeueStellung(Child.Brett1.GetBrStellung, Child.Brett1.GetBrZug, 1);
        Child.Notation1.Geaendert := false;
        Child.sbReplace.Enabled := false;
//        Child.Notation1FischerInfo(self, Child.FRC^);
      end;
      Child.Caption := Child.Notation1.Partiedaten.EventData.Weiss +
      ' - ' + Child.Notation1.Partiedaten.EventData.Schwarz;
      Child.Splitter1Moved(self);
    finally
      Child.Brett1.LockBoardUpdate := false;
      Child.Brett1.BoardRefresh;
    end;
    if tacticPGN = PGN then with Child do begin
      sbReplace.Enabled := false;
      sbSave.Enabled := false;
      bUndo.Enabled := false;
      bCut.Enabled := false;
      bDelete.Enabled := false;
      mAufwerten.Enabled := false;
      bComment.Enabled := false;
      bNew.Enabled := false;
      Brett1.Popupmenu := Nil;
      Brett1.ZiehenMoeglich := false;
      Notation1.Popupmenu := Nil;
      pForderung.Visible := true;
      lForderung.Caption := Child.DecodeAnnotator;
    end;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TMainForm.HandleLang(Sender : TObject);
Var sl : TStringList;
    i : integer;
    s : String;

    function ReplaceNotekey(s : string) : string;
    Var i : Integer;
    begin
      Result := s;
      For i := 1 to length(Result) do
        if Result[i] = '' then Result[i] := #13;
    end;

begin
  if Sender is TMenuItem then with Sender as TMenuItem do begin
    s := '';
    For i := 1 to length(Caption) do
      if Caption[i] <> '&' then
        s := s + Caption[i];
    if uppercase(s) = 'DEUTSCH' then LO_lng := LO_German
    else begin
      LO_lng := LO_English;
      otherLang := s;
      sl := TStringList.Create;
      try
        sl.LoadFromFile(verzeichnis + s + '.lng');
        for i := 0 to sl.Count - 1 do begin
          if i >= LO_MessMax then System.break;
          LOMess[i, 1] := ReplaceNotekey(sl[i]);
        end;
      finally
        sl.free;
      end;
    end;
    Checked := true;
    LOLoadMenuStrings(LO_lng);
    for I := MDIChildCount - 1 downto 0 do begin
      if MDIChildren[I] is TMDIDatabase then LOLoadDataBaseWinStrings(LO_lng, MDIChildren[I] as TMDIDatabase);
      if MDIChildren[I] is TMDIBrett then LOLoadBrettWinStrings(LO_lng, MDIChildren[I] as TMDIBrett);
      if MDIChildren[I] is TMDIPGN then LOLoadPGNWinStrings(LO_lng, MDIChildren[I] as TMDIPGN);
    end;
  end;
end;

procedure TMainForm.SetLang(s : string);
Var mItem : TMenuItem;
    i : integer;
begin
  if mSprache.Count = 0 then exit;
  mItem := mSprache.Items[0];
  if (LO_lng <> LO_German) and (mSprache.Count > 1) then begin
    for i := 1 to mSprache.Count - 1 do begin
      if uppercase(mSprache.Items[i].Caption) = uppercase(s) then begin
        mItem := mSprache.Items[i];
        break;
      end;
    end;
  end;
  handleLang(TObject(mItem));
end;

procedure TMainForm.FormCreate(Sender: TObject);
Var SearchRec : TSearchRec;
    i : integer;
    sl : TStringlist;
    shint, newDir, exename : String;
    s : string;
    fett : Boolean;
    f : File;
    rh, mh : integer;
    Data : pointer;
    DataSize : integer;

    function WinDir: string;
    var
      Buffer: PChar;
      Size: Word;
    begin
      Size := 144;
      GetMem(Buffer,144);
      if GetWindowsDirectory(Buffer, Size) >0 then begin
        Result := StrPas(Buffer);
        if Result[length(Result)] <> '\' then Result := Result + '\';
      end
      else Result := '';
      FreeMem(Buffer,144);
    end;

function GetSpecialFolder(hWindow: HWND; Folder: Integer): String;
var
  pMalloc: IMalloc;
  pidl: PItemIDList;
  Path: PChar;
begin
  Result := '';
  try
    if (SHGetMalloc(pMalloc) <> S_OK) then
      Exit;
    SHGetSpecialFolderLocation(hWindow, Folder, pidl);
    GetMem(Path, MAX_PATH);
    SHGetPathFromIDList(pidl, Path);
    Result := Path;
    FreeMem(Path);
    pMalloc.Free(pidl);
  except
  end;
end;

  function installFont(filename : String) : Boolean;
  Var i, j : integer;
      FontDateiName, WinFontDir : string;
  begin
    Result := false;
    try
      WinFontDir := GetSpecialFolder(Handle, CSIDL_FONTS);
      if WinFontDir = '' then exit;
      WinFontDir :=  IncludeTrailingPathDelimiter(WinFontDir); 

      FontDateiName := WinFontDir + InfFontFilenameWithoutExt;
      if CopyFile(PChar(filename),  PChar(FontDateiname + '.TTF'), false) then begin
        if CreateScalableFontResource(0, PChar(FontDateiname + '.fot'),
        PChar(FontDateiName + '.ttf'), nil)
        then begin
          AddFontResource(PChar(FontDateiName + '.ttf'));
        end;
      end;
      SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);
      Result := true;
    except
    end;
  end;

  procedure AddItem(scaption : String; i : integer);
  Var MenuItem : TMenuItem;
  begin
    MenuItem := TMenuItem.Create(self);
    MenuItem.Caption := scaption;
    MenuItem.ShortCut := TextToShortcut('Alt+' + IntToStr(i));
    MenuItem.OnClick := HandleLang;
    MenuItem.GroupIndex := 1;
    MenuItem.RadioItem := true;
    mSprache.Insert(i - 1, MenuItem);
  end;

  function Replace13(s : String) : string;
  var i : integer;
  begin
    Result := s;
    for i := 1 to length(Result) do if Result[i] = #13 then Result[i] := '';
  end;

function MakeStartMenuLink(Name, Folder, ExeName, WorkingDir: String): Boolean;
var
  AReg: TRegIniFile;
  AObject: IUnknown;
  ASLink: IShellLink;
  APFile: IPersistFile;
  Directory: String;
  WFileName: WideString;
  R: HRESULT;
  Error: Boolean;
begin
  MakeStartMenuLink:= false;
  try
    CoInitializeEx (NIL, COINIT_APARTMENTTHREADED);
    try
      Error:= false;
      AObject:= CreateComObject(CLSID_ShellLink);
      ASLink:= AObject as IShellLink;
      APFile:= AObject as IPersistFile;
      with ASLink do begin	//Set the parameters
        SetArguments('');
        SetPath(PChar(ExeName));
        SetWorkingDirectory(PChar(WorkingDir));
      end;
      AReg:= TRegIniFile.Create('Software\MicroSoft\Windows\CurrentVersion\Explorer');
      Directory:= AReg.ReadString('Shell Folders', 'Programs', '')+'\'+Folder;
      if not DirectoryExists(Directory) then Error:= true;
      WFileName:= Directory+'\'+Name+'.lnk';
      R:= APFile.Save(PWChar(WFileName),False);
      if R= E_FAIL then Error:= true;
      AReg.Free;
      MakeStartMenuLink:= Error;
    finally
      CoUninitialize;
    end;  
  except
  end;
end;

function MakeStartMenuFolder(Name: String): Boolean;
var
  Directory: String;
  AReg: TRegIniFile;
  Error: Boolean;
begin
  MakeStartMenuFolder:= false;
  try
    Error:= false;
    AReg:= TRegIniFile.Create('Software\MicroSoft\Windows\CurrentVersion\Explorer');
    Directory:= AReg.ReadString('Shell Folders', 'Programs', '');
    if not DirectoryExists(Directory) then Error:= true;
    CreateDir(Directory+'\' + Name);
    AReg.Free;
    MakeStartMenuFolder:= Error;
  except
  end;
end;


function InsertRet(z : string) : string;
Var i : integer;
begin
  Result := trim(z);
  i := 1;
  while i <= length(Result) do begin
    if Result[i] = ' ' then begin
      while (i <= length(Result)) and (Result[i] = ' ') do begin
        Delete(Result, i, 1);
      end;
      insert(Ret, Result, i);
    end;
    inc(i);
  end;
end;

function CopyData(FileName : string; Data : pointer; DataSize : integer) : boolean;
var
  f : file of byte;
  r : integer;
begin
  {$I-}
  AssignFile(f,FileName);
  rewrite(f);
  BlockWrite(f,Data^,DataSize,r);
  CloseFile(f);
  IOResult;
  Result:=r=DataSize;
end;


begin
  verzeichnis := ExtractFilePath(Application.ExeName);
  if (ParamCount = 0) and (not FileExists(verzeichnis + sIniFileName)) then begin
    left := screen.Width;
    top := screen.Height;
    if SysLocale.PriLangID = LANG_GERMAN then
      shint := sCompoChess + #13 + '(Schachdatenbank)' + #13#13 +
      'Dieses Programm ist Freeware.' + #13#13 +
      'Es wird keine Garantie fr eine fehlerfreie Programmausfhrung und keine Haftung fr ev. Schden, die durch die Anwendung dieser Software entstehen knnten, bernommen.' + #13#13 +
      'Drcken Sie OK, und whlen Sie dann das Installations-Verzeichnis aus.'
    else shint := sCompoChess + #13 + '(Chess Database)' + #13#13 +
      'This program is freeware. That means, you may use it freely for any purpose.' + #13#13 +
      'This software is provided ''as-is'', without any express or implied warranty. In no event the author will be held liable for any damages arising from the use of this software.' + #13#13 +
      'Press OK to continue and select the installation folder then.';
    if MessageDlg(shint, mtInformation, [mbOk, mbCancel], 0)
    = mrOk then begin
      if SysLocale.PriLangID = LANG_GERMAN then
        shint := sCompoChess + ' wird nun installiert. Bitte whlen Sie das Installations-Verzeichnis.'
      else
        shint := sCompoChess + ' will be installed now. Please select the installation folder.';
      newDir := ExcludeTrailingPathDelimiter(WinDir);
      i := length(newDir);
      while i > 0 do begin
        if newDir[i] = '\' then begin
          newDir := copy(newDir, 1, i);
          break;
        end;
        dec(i);
      end;
      if SelectDirectory(shint, '', newDir) then try
        exename := 'compochess.exe';
        if (newDir <> '') and (newDir[length(newDir)] <> '\') then
          newDir := newDir + '\';
        if copy(uppercase(newDir), length(newDir) - 10, length(newDir)) <> uppercase(sCompoChess) + '\' then
          newDir := newDir + sCompoChess + '\';
        if uppercase(verzeichnis) <> uppercase(newDir) then begin
          ForceDirectories(newDir);
          if DirectoryExists(newDir) then begin
            CopyFile(PChar(Application.ExeName), PChar(newDir + exename), false);
            assignFile(f, newDir + sIniFileName);
            rewrite(f);
            closeFile(f);

            try
              GetFontNames;
              if not InfFontInstalled then begin   // for chess informant signs - you might include a special font providing those symbols
                rh := FindResource(0,Pointer(1),'FILE');
                if rh <> 0 then begin
                  mh := LoadResource(0,rh);
                  DataSize := SizeOfResource(0,rh);
                  if mh <> 0 then begin
                    Data := LockResource(mh);
                    if Data<>nil then begin
                      CopyData(newDir + InfFontFilename, Data, DataSize);  // Daten in Datei
                      UnlockResource(mh);
                    end;
                    FreeResource(mh);
                    installFont(newDir + InfFontFilename);
                    DeleteFile(newDir + InfFontFilename);
                  end;
                end;
              end;  

              if not MakeStartMenuFolder(sCompoChess) then
                MakeStartMenuLink(sCompoChess, sCompoChess, newDir + exename, '');
              assignExt(sCompoChess, sCompoChessExt, newDir + exename);
            except
            end;

            ShellExecute(handle, 'open', PChar(newDir + exename), '', '', SW_SHOWNORMAL);
          end
          else begin
            if SysLocale.PriLangID = LANG_GERMAN then
              shint := 'Fehler beim Anlegen des Installations-Verzeichnisses. Mglicherweise ist es schreibgeschtzt.'
            else shint := 'Error while creating the installation folder. Maybe it is write protected.';
            MessageDlg(shint, mtError, [mbOk], 0);
          end;
        end;
      except
      end;
    end;
    Application.Terminate;
    exit;
  end;

  mKombis.visible :=  (FileExists(verzeichnis + 't1.pgn'))
                   or (FileExists(verzeichnis + 't1.kom'));
  Application.OnHint := ShowHint;
  Screen.OnActiveFormChange := UpdateMenuItems;
  slDatabase := TStringlist.Create;
  slEngines := TStringlist.Create;
  lf := TList.Create;
  Prot := TProtokoll.Create(verzeichnis + sLogfile); // kann mit DisableLog in .ini abgeschaltet werden
  Randomize;  {fr Aufbauen einer Fischer-R.-C.-Ausgangsstellung}
  LOSaveMenuStrings;
  try
    sl := TStringlist.Create;
    try
      For i := 0 to LO_MessMax - 1 do begin
        sl.Add( Replace13(LOMess[i, 1]));
      end;
      sl.SavetoFile(verzeichnis + sEnglishFile);
    finally
      sl.free;
    end;
    AddItem('Deutsch', 1);
    i := 2;
    if FindFirst(verzeichnis + '*.lng' , faAnyFile, SearchRec) = 0 then begin
      repeat
        AddItem(copy(SearchRec.Name, 1, length(SearchRec.Name) - 4), i);
        inc(i);
      until FindNext(SearchRec) <> 0;
      FindClose(SearchRec);
    end;
  except
  end;

  with TIniFile.Create(verzeichnis + sIniFileName) do try
    For i := 0 to maxHist - 1 do begin
      s := ReadString(sHistory, 'File' + IntToStr(i), '');
 //ccf     if CheckPGN(ListboxNameToDatabaseName(s)) then
         slDatabase.Add(s);
    end;
    SaveDataBase := ReadString(sHistory, 'SaveDataBase', '');
    mClickClick.Checked := ReadBool(sOptions, 'ClickClick', false);
    FontDialog1.Font.Name := ReadString(sOptions, 'FontName', InfFontName);
    FontDialog1.Font.Size := ReadInteger(sOptions, 'FontSize', 10);
    fett := ReadBool(sOptions, 'FontBold', True);
    if fett then FontDialog1.Font.Style:=[fsBold]
    else FontDialog1.Font.Style:=[];
    FontDialog1.Font.Color := ReadInteger(sOptions, 'FontColor', clBlack);
    FontDialogComm.Font.Name := ReadString(sOptions, 'CFontName', 'Arial');
    FontDialogComm.Font.Size := ReadInteger(sOptions, 'CFontSize', 10);
    fett := ReadBool(sOptions, 'CFontBold', false);
    if fett then FontDialogComm.Font.Style:=[fsBold]
    else FontDialogComm.Font.Style:=[];
    FontDialogComm.Font.Color := ReadInteger(sOptions, 'CFontColor', clMaroon);
 //   mFRC.Checked := ReadBool(sOptions, 'FRC', false);
    LO_lng := ReadInteger(sOptions, 'English', -1);
    if LO_lng = -1 then
      if SysLocale.PriLangID = LANG_ENGLISH then
        LO_lng := LO_English
      else
        LO_lng := LO_German;
    otherLang := ReadString(sOptions, 'otherLang', 'English');
    SetLang(otherLang);
    mShowLastMove.Checked := ReadBool(sOptions, 'ShowLastMove', false);
    mAnimation.Checked := ReadBool(sOptions, 'Animation', true);
    if LO_lng <> LO_German then LOLoadMenuStrings(LO_lng);
    Brettheight := ReadInteger(sOptions, 'BrettHeight', 0);
    Brettwidth := ReadInteger(sOptions, 'BrettWidth', 0);
    BrettSize := ReadInteger(sOptions, 'BrettSize', 0);
    BrettTop := ReadInteger(sOptions, 'BrettTop', 0);
    BrettLeft := ReadInteger(sOptions, 'BrettLeft', 0);
    WhiteOnTop := ReadBool(sOptions, 'WhiteOnTop', false);
    fett := ReadBool(sOptions, 'BrettMax', false);
    if fett then BrettState := wsMaximized
    else BrettState := wsNormal;
    PGNheight := ReadInteger(sOptions, 'PGNHeight', 0);
    PGNwidth := ReadInteger(sOptions, 'PGNWidth', 0);
    PGNTop := ReadInteger(sOptions, 'PGNTop', 0);
    PGNLeft := ReadInteger(sOptions, 'PGNLeft', 0);
    Databaseheight := ReadInteger(sOptions, 'DatabaseHeight', 0);
    Databasewidth := ReadInteger(sOptions, 'DatabaseWidth', 0);
    Mainheight := ReadInteger(sOptions, 'MainHeight', 0);
    Mainwidth := ReadInteger(sOptions, 'MainWidth', 0);
    Maintop := ReadInteger(sOptions, 'MainTop', 0);
    MainLeft := ReadInteger(sOptions, 'MainLeft', 0);
    BlackSquare := ReadInteger(sOptions, 'BlackSquare', 0);
    WhiteSquare := ReadInteger(sOptions, 'WhiteSquare', 0);
    DatabaseWinEnabled := ReadBool(sOptions, 'DatabaseWinEnabled' , false);
    DatabaseFolder := ReadString(sOptions, 'DatabaseFolder' , '');
    figK := ReadString(sOptions, 'figK', '');
    figQ := ReadString(sOptions, 'figQ', '');
    figR := ReadString(sOptions, 'figR', '');
    figB := ReadString(sOptions, 'figB', '');
    figN := ReadString(sOptions, 'figN', '');
    figP := ReadString(sOptions, 'figP', '');
    InformantSigns := ReadString(sOptions, 'InformantSigns', '');

    with WBInfo do begin
      setWBDefaults;

      s := ReadString(sEngine, 'Parameter', '');
      if s <> '' then begin WBParam := s; UserdefinedEngineParam := true; end; // keine Ret dazwischen
      s := ReadString(sEngine, 'Init', '');
      if s <> '' then begin WBIni := InsertRet(s) + ret; UserdefinedEngineParam := true; end;
      s    := ReadString(sEngine, 'SetPosition', '');
      if s <> '' then begin WbSetBoard := InsertRet(s); UserdefinedEngineParam := true; end;  // kein ret dahinter
      s:= ReadString(sEngine, 'StartAnalyze', '');
      if s <> '' then begin WbStartAnalyze := InsertRet(s) + ret; UserdefinedEngineParam := true; end;
      s := ReadString(sEngine, 'StopAnalyze', '');
      if s <> '' then begin WbStopAnalyze := InsertRet(s) + ret; UserdefinedEngineParam := true; end;
      s        := ReadString(sEngine, 'Quit', '');
      if s <> '' then begin WbQuit := InsertRet(s) + ret; UserdefinedEngineParam := true; end;
      s    := ReadString(sEngine, 'GetState', '');
      if s <> '' then begin WbGetstate := InsertRet(s) + ret; UserdefinedEngineParam := true; end;
      WbNoParseOutput := ReadBool(sEngine, 'NoParseOutput', false);
    end;
    For i := 0 to 7 do begin
      s := ReadString(sEngineNames, 'WBEngine' + IntToStr(i), '');
      if s <> ''
        then slEngines.Add(s);
    end;
    m1Echecs.Checked := ReadBool(sOptions, '1Echecs' , true);
    GameMin := ReadInteger(sOptions, 'GameTime', 5);
    if GameMin < 1 then
      GameMin := 1;
    MoveSec := ReadInteger(sOptions, 'MoveTime', 5);
    mToolbarBelow.Checked := ReadBool(sOptions, 'ToolbarBelow', false);
    Prot.LogDisabled := ReadBool(sOptions, 'DisableLog', true)  
  finally
    free;
  end;
  if Mainheight > 100 then Height := Mainheight;
  if Mainwidth > 100 then Width := Mainwidth;
  if MainTop + Mainheight < Screen.Height then
    top := MainTop
  else
    Top := 0;
  if MainLeft + Mainwidth < Screen.width then
    Left := MainLeft
  else
    Left := 0;
  PostMessage(handle, WM_LOADFILE, 0, 0);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Screen.OnActiveFormChange := nil;
  slDatabase.Free;
  slEngines.Free;
  lf.Free;
  if Prot <> Nil then
    Prot.Free;
end;

procedure TMainForm.ShowHint(Sender: TObject);
begin
  pHint.Caption := Application.Hint;
end;

procedure TMainForm.mCloseClick(Sender: TObject);
begin
  if ActiveMDIChild <> nil then
    ActiveMDIChild.Close;
end;

procedure TMainForm.WindowCascadeItemClick(Sender: TObject);
begin
  Cascade;
end;

procedure TMainForm.WindowTileItemClick(Sender: TObject);
begin
  Tile;
end;

procedure TMainForm.WindowArrangeItemClick(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TMainForm.WindowMinimizeItemClick(Sender: TObject);
var
  I: Integer;
begin
  for I := MDIChildCount - 1 downto 0 do
    MDIChildren[I].WindowState := wsMinimized;
end;

procedure TMainForm.UpdateMenuItems(Sender: TObject);
begin
  mClose.Enabled := MDIChildCount > 0;
  WindowCascadeItem.Enabled := MDIChildCount > 0;
  WindowTileItem.Enabled := MDIChildCount > 0;
  WindowArrangeItem.Enabled := MDIChildCount > 0;
  WindowMinimizeItem.Enabled := MDIChildCount > 0;
end;
      
procedure TMainForm.HelpAboutItemClick(Sender: TObject);
begin
  with TAboutBox.Create(self) do try
    ShowModal;
  finally
    free;
  end;
  Prot.flush;    
end;

procedure TMainForm.bStopClick(Sender: TObject);
begin
  Abbrechen := true;
end;

procedure TMainForm.mExitClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.mGameOpenClick(Sender: TObject);
begin
  CreateMDIBrettChild(Nil, '', pgnAddGame, false);
end;

procedure TMainForm.mHistoryClick(Sender: TObject);
begin
  if MDIDatabase <> Nil then
    MDIDatabase.BringToFront
  else begin
    MDIDatabase := TMDIDatabase.Create(Application);
    MDIDatabase.lbDatabase.Items.Assign(slDatabase);
  end;  
end;

procedure TMainForm.LoadFile(Var Msg : TMsg);
var PGN : TPGN;
    s : String;
    iParCount, aID, Nr : longint;
    i : longint;
begin
  try
    if DatabaseWinEnabled
      then mHistoryClick(self);
    PGN := Nil;
    s := '';
    iParCount := ParamCount;
    if iParCount > 0 then s := Paramstr(1);
    if s <> '' then begin
      CreateMDIPGNChild(s);
      for I := MDIChildCount - 1 downto 0 do  { anfangs ist nur eine geffnet }
        if MDIChildren[I] is TMDIPGN then with MDIChildren[I] as TMDIPGN do
          PGN := PGN1;
      if (
        (PGN <> Nil) and
        (iParCount > 1) or (PGN.ItemsAllCount = 1)
      ) then begin
        aID := 0;
        Nr := 0;
        if iParCount > 1 then begin
          s := Paramstr(2);  { Geme number entered? }
          val(s, Nr, aID);
        end
        else if PGN.ItemsAllCount = 1 then begin
            // if there are only one game, open it
        end
        else aID := 1;
        if aID = 0 then begin
          s := PGN.GetGameAsString(PGN.ListeIndexToDatabaseIndex(Nr), aID);
          if s <> '' then CreateMDIBrettChild(PGN, s, aID, false);
        end;
      end;
    end;
  except
  end;
end;

procedure TMainForm.setWBDefaults;
begin
  with WBInfo do begin
    WBParam       := WBCraftyParam;
    WBIni         := WBCraftyIni;
    WbSetBoard    := WbCraftySetBoard;
    WbStartAnalyze:= WbCraftyStartAnalyze;
    WbStopAnalyze := WbCraftyStopAnalyze;
    WbQuit        := WbCraftyQuit;
    WbGetstate    := WbCraftyGetState;
    WbNoParseOutput := false;
  end;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
Var s : string;
    i : integer;
    fett : Boolean;
begin               
  if Working then begin
    CanClose := false;
    exit;
  end;
  try
    if not doNotWriteIni then
    with TIniFile.Create(verzeichnis + sIniFileName) do try
      For i := 0 to maxHist - 1 do begin
        if i < slDatabase.Count then s := slDatabase[i]
        else s := '';
        WriteString(sHistory, 'File' + IntToStr(i), s);
      end;
      WriteString(sHistory, 'SaveDataBase', SaveDataBase);
      WriteBool(sOptions, 'DatabaseWinEnabled' , MDIDatabase <> Nil);
      WriteString(sOptions, 'DatabaseFolder' , DatabaseFolder);
      WriteBool(sOptions, 'ClickClick', mClickClick.Checked);
      WriteString(sOptions, 'FontName', FontDialog1.Font.Name);
      WriteInteger(sOptions, 'FontSize', FontDialog1.Font.Size);
      if fsBold in FontDialog1.Font.Style then fett:=true else fett:=false;
      WriteBool(sOptions, 'FontBold', fett);
      WriteInteger(sOptions, 'FontColor', FontDialog1.Font.Color);
      WriteString(sOptions, 'CFontName', FontDialogComm.Font.Name);
      WriteInteger(sOptions, 'CFontSize', FontDialogComm.Font.Size);
      if fsBold in FontDialogComm.Font.Style then fett:=true else fett:=false;
      WriteBool(sOptions, 'CFontBold', fett);
      WriteInteger(sOptions, 'CFontColor', FontDialogComm.Font.Color);
    //  WriteBool(sOptions, 'FRC', mFRC.Checked);
      WriteInteger(sOptions, 'English', LO_lng);
      WriteString(sOptions, 'otherLang', otherLang);
      WriteBool(sOptions, 'ShowLastMove', mShowLastMove.Checked);
      WriteBool(sOptions, 'Animation', mAnimation.Checked);
      WriteInteger(sOptions, 'BrettHeight', Brettheight);
      WriteInteger(sOptions, 'BrettWidth', Brettwidth);
      WriteInteger(sOptions, 'BrettSize', BrettSize);
      WriteInteger(sOptions, 'BrettTop', BrettTop);
      WriteInteger(sOptions, 'BrettLeft', BrettLeft);
      WriteBool(sOptions, 'WhiteOnTop', WhiteOnTop);
      if BrettState = wsMaximized then fett := true
      else fett := false;
      WriteBool(sOptions, 'BrettMax', fett);
      WriteInteger(sOptions, 'PGNHeight', PGNheight);
      WriteInteger(sOptions, 'PGNWidth', PGNwidth);
      WriteInteger(sOptions, 'PGNTop', PGNTop);
      WriteInteger(sOptions, 'PGNLeft', PGNLeft);
      WriteInteger(sOptions, 'DatabaseHeight', Databaseheight);
      WriteInteger(sOptions, 'DatabaseWidth', Databasewidth);
      if Windowstate = wsNormal then begin
        WriteInteger(sOptions, 'MainHeight', height);
        WriteInteger(sOptions, 'MainWidth', width);
        WriteInteger(sOptions, 'MainTop', top);
        WriteInteger(sOptions, 'MainLeft', Left);
      end;
      WriteInteger(sOptions, 'BlackSquare', BlackSquare);
      WriteInteger(sOptions, 'WhiteSquare', WhiteSquare);
      WriteString(sOptions, 'figK', figK);
      WriteString(sOptions, 'figQ', figQ);
      WriteString(sOptions, 'figR', figR);
      WriteString(sOptions, 'figB', figB);
      WriteString(sOptions, 'figN', figN);
      WriteString(sOptions, 'figP', figP);
      WriteString(sOptions, 'InformantSigns', InformantSigns);

      For i := 0 to 7 do begin
        if i < slEngines.Count then s := slEngines[i]
        else s := '';
        WriteString(sEngineNames, 'WBEngine' + IntToStr(i), s);
      end;
      WriteBool(sOptions, '1Echecs' , m1Echecs.Checked);

      WriteInteger(sOptions, 'GameTime', GameMin);
      WriteInteger(sOptions, 'MoveTime', MoveSec);
      WriteBool(sOptions, 'ToolbarBelow', mToolbarBelow.Checked);
    finally
      free;
    end;
  except
  end;  
end;

procedure TMainForm.mShowLastMoveClick(Sender: TObject);
begin
  mShowLastMove.Checked := not mShowLastMove.Checked;
end;

procedure TMainForm.mAnimationClick(Sender: TObject);
Var i : Integer;
begin
  mAnimation.Checked := not mAnimation.Checked;
  for I := MDIChildCount - 1 downto 0 do if MDIChildren[I] is TMDIBrett
    then if mAnimation.Checked then (MDIChildren[I] as TMDIBrett).Brett1.Animation := 1
    else (MDIChildren[I] as TMDIBrett).Brett1.Animation := 0;
end;

procedure TMainForm.mClickClickClick(Sender: TObject);
Var i : Integer;
begin
  mClickClick.Checked := not mClickClick.Checked;
  for I := MDIChildCount - 1 downto 0 do if MDIChildren[I] is TMDIBrett
    then (MDIChildren[I] as TMDIBrett).Brett1.ClickAndClick := mClickClick.Checked;
end;

procedure TMainForm.mBlackSquareClick(Sender: TObject);
Var f : TMDIBrett;
    I : Integer;
begin
  ColorDialog1.Color := BlackSquare;
  if ColorDialog1.Execute then begin
    BlackSquare := ColorDialog1.Color;
    for I := MDIChildCount - 1 downto 0 do if MDIChildren[I] is TMDIBrett
      then (MDIChildren[I] as TMDIBrett).Brett1.BlackSquareColor := ColorDialog1.Color;
  end;
end;

procedure TMainForm.mWhiteSquareClick(Sender: TObject);
Var f : TMDIBrett;
    I : Integer;
begin
  ColorDialog1.Color := WhiteSquare;
  if ColorDialog1.Execute then begin
    WhiteSquare := ColorDialog1.Color;
    for I := MDIChildCount - 1 downto 0 do if MDIChildren[I] is TMDIBrett
      then (MDIChildren[I] as TMDIBrett).Brett1.WhiteSquareColor := ColorDialog1.Color;
  end;
end;

procedure TMainForm.mFontCommClick(Sender: TObject);
Var I : Integer;
begin
  if FontDialogComm.Execute then
    for I := MDIChildCount - 1 downto 0 do if MDIChildren[I] is TMDIBrett
      then (MDIChildren[I] as TMDIBrett).Notation1.FontComment := FontDialogComm.Font;
end;

procedure TMainForm.mFontClick(Sender: TObject);
Var I : Integer;
    ABitmap : TBitmap;
    b : TMDIBrett;
begin
  with TfrmPieces.Create(self) do try
    fEdit1.Text := figK;
    fEdit2.Text := figQ;
    fEdit3.Text := figR;
    fEdit4.Text := figB;
    fEdit5.Text := figN;
    fEdit6.Text := figP;

    for i := 0 to 18 do begin
      ABitmap := TBitmap.Create;
      try
        ImageListBold.GetBitmap(i, ABitmap);
        case i of
          0  : Image1.Picture.Bitmap.Assign(ABitmap); 
          1  : Image2.Picture.Bitmap.Assign(ABitmap); 
          2  : Image3.Picture.Bitmap.Assign(ABitmap);
          3  : Image4.Picture.Bitmap.Assign(ABitmap); 
          4  : Image5.Picture.Bitmap.Assign(ABitmap);
          5  : Image6.Picture.Bitmap.Assign(ABitmap); 
          6  : Image7.Picture.Bitmap.Assign(ABitmap); 
          7  : Image8.Picture.Bitmap.Assign(ABitmap); 
          8  : Image9.Picture.Bitmap.Assign(ABitmap);
          9  : Image10.Picture.Bitmap.Assign(ABitmap);
          10 : Image11.Picture.Bitmap.Assign(ABitmap);
          11 : Image12.Picture.Bitmap.Assign(ABitmap);
          12 : Image13.Picture.Bitmap.Assign(ABitmap);
          13 : Image14.Picture.Bitmap.Assign(ABitmap);
          14 : Image15.Picture.Bitmap.Assign(ABitmap);
          15 : Image16.Picture.Bitmap.Assign(ABitmap);
          16 : Image17.Picture.Bitmap.Assign(ABitmap);
          17 : Image18.Picture.Bitmap.Assign(ABitmap);
          18 : Image19.Picture.Bitmap.Assign(ABitmap);
        end;
        ABitmap.Free;
      except
        ABitmap.Free;
      end;
    end;
    if length(InformantSigns) >  0 then  if InformantSigns[1] <> '#' then Edit1.Text  := InformantSigns[1];
    if length(InformantSigns) >  1 then  if InformantSigns[2] <> '#' then Edit2.Text  := InformantSigns[2];
    if length(InformantSigns) >  2 then  if InformantSigns[3] <> '#' then Edit3.Text  := InformantSigns[3];
    if length(InformantSigns) >  3 then  if InformantSigns[4] <> '#' then Edit4.Text  := InformantSigns[4];
    if length(InformantSigns) >  4 then  if InformantSigns[5] <> '#' then Edit5.Text  := InformantSigns[5];
    if length(InformantSigns) >  5 then  if InformantSigns[6] <> '#' then Edit6.Text  := InformantSigns[6];
    if length(InformantSigns) >  6 then  if InformantSigns[7] <> '#' then Edit7.Text  := InformantSigns[7];
    if length(InformantSigns) >  7 then  if InformantSigns[8] <> '#' then Edit8.Text  := InformantSigns[8];
    if length(InformantSigns) >  8 then  if InformantSigns[9] <> '#' then Edit9.Text  := InformantSigns[9];
    if length(InformantSigns) >  9 then  if InformantSigns[10] <> '#' then Edit10.Text := InformantSigns[10];
    if length(InformantSigns) > 10 then  if InformantSigns[11] <> '#' then Edit11.Text := InformantSigns[11];
    if length(InformantSigns) > 11 then  if InformantSigns[12] <> '#' then Edit12.Text := InformantSigns[12];
    if length(InformantSigns) > 12 then  if InformantSigns[13] <> '#' then Edit13.Text := InformantSigns[13];
    if length(InformantSigns) > 13 then  if InformantSigns[14] <> '#' then Edit14.Text := InformantSigns[14];
    if length(InformantSigns) > 14 then  if InformantSigns[15] <> '#' then Edit15.Text := InformantSigns[15];
    if length(InformantSigns) > 15 then  if InformantSigns[16] <> '#' then Edit16.Text := InformantSigns[16];
    if length(InformantSigns) > 16 then  if InformantSigns[17] <> '#' then Edit17.Text := InformantSigns[17];
    if length(InformantSigns) > 17 then  if InformantSigns[18] <> '#' then Edit18.Text := InformantSigns[18];
    if length(InformantSigns) > 18 then  if InformantSigns[19] <> '#' then Edit19.Text := InformantSigns[19];
    if Showmodal = mrOk then begin
      figK := trim(fEdit1.Text);
      figQ := trim(fEdit2.Text);
      figR := trim(fEdit3.Text);
      figB := trim(fEdit4.Text);
      figN := trim(fEdit5.Text);
      figP := trim(fEdit6.Text);

      InformantSigns := '';
      if length(Edit1.Text ) = 1 then InformantSigns := InformantSigns + Edit1.Text else InformantSigns := InformantSigns + '#'   ;
      if length(Edit2.Text ) = 1 then InformantSigns := InformantSigns + Edit2.Text else InformantSigns := InformantSigns + '#'   ;
      if length(Edit3.Text ) = 1 then InformantSigns := InformantSigns + Edit3.Text else InformantSigns := InformantSigns + '#'   ;
      if length(Edit4.Text ) = 1 then InformantSigns := InformantSigns + Edit4.Text else InformantSigns := InformantSigns + '#'   ;
      if length(Edit5.Text ) = 1 then InformantSigns := InformantSigns + Edit5.Text else InformantSigns := InformantSigns + '#'   ;
      if length(Edit6.Text ) = 1 then InformantSigns := InformantSigns + Edit6.Text else InformantSigns := InformantSigns + '#'   ;
      if length(Edit7.Text ) = 1 then InformantSigns := InformantSigns + Edit7.Text else InformantSigns := InformantSigns + '#'   ;
      if length(Edit8.Text ) = 1 then InformantSigns := InformantSigns + Edit8.Text else InformantSigns := InformantSigns + '#'   ;
      if length(Edit9.Text ) = 1 then InformantSigns := InformantSigns + Edit9.Text else InformantSigns := InformantSigns + '#'   ;
      if length(Edit10.Text) = 1 then InformantSigns := InformantSigns + Edit10.Text else InformantSigns := InformantSigns + '#'  ;
      if length(Edit11.Text) = 1 then InformantSigns := InformantSigns + Edit11.Text else InformantSigns := InformantSigns + '#'  ;
      if length(Edit12.Text) = 1 then InformantSigns := InformantSigns + Edit12.Text else InformantSigns := InformantSigns + '#'  ;
      if length(Edit13.Text) = 1 then InformantSigns := InformantSigns + Edit13.Text else InformantSigns := InformantSigns + '#'  ;
      if length(Edit14.Text) = 1 then InformantSigns := InformantSigns + Edit14.Text else InformantSigns := InformantSigns + '#'  ;
      if length(Edit15.Text) = 1 then InformantSigns := InformantSigns + Edit15.Text else InformantSigns := InformantSigns + '#'  ;
      if length(Edit16.Text) = 1 then InformantSigns := InformantSigns + Edit16.Text else InformantSigns := InformantSigns + '#'  ;
      if length(Edit17.Text) = 1 then InformantSigns := InformantSigns + Edit17.Text else InformantSigns := InformantSigns + '#'  ;
      if length(Edit18.Text) = 1 then InformantSigns := InformantSigns + Edit18.Text else InformantSigns := InformantSigns + '#'  ;
      if length(Edit19.Text) = 1 then InformantSigns := InformantSigns + Edit19.Text else InformantSigns := InformantSigns + '#'  ;

      for I := self.MDIChildCount - 1 downto 0 do
      if self.MDIChildren[I] is TMDIBrett then begin
        b := self.MDIChildren[I] as TMDIBrett;
        b.Notation1.LockNotatUpdate := true;
        b.Notation1.SetPiecesNames(figK, figQ, figR, figB, figN, figP);
        b.Notation1.Font0Var := FontDialog1.Font;
        b.Notation1.LockNotatUpdate := false;
        b.Notation1.SetInformantSigns(InformantSigns);
      end;
    end;  
  finally
    free;
  end;
end;

procedure TMainForm.taggleAnalysis(stop : Boolean);
var i : Integer;
begin
  for I := MDIChildCount - 1 downto 0 do
    if MDIChildren[I] is TMDIBrett then
      if stop then
        TMDIBrett(MDIChildren[I]).SuspendAnalyse
      else
        TMDIBrett(MDIChildren[I]).ResumeAnalyse;
end;

procedure TMainForm.Engines1Click(Sender: TObject);
var i : Integer;
begin
  with TfrmEngines.Create(self) do try
    Listbox1.Items.Assign(slEngines);
    ShowModal;
    slEngines.Assign(Listbox1.Items);
    for i := 0 to self.MDIChildCount - 1 do
      if self.MDIChildren[i] is TMDIBrett then
        (self.MDIChildren[i] as TMDIBrett).setEngineMenu;
  finally
    free;
  end;
end;

procedure TMainForm.m1EchecsClick(Sender: TObject);
begin
  m1Echecs.Checked := true;
end;

procedure TMainForm.mChessMeridaClick(Sender: TObject);
begin
  mChessMerida.Checked := true;
end;

procedure TMainForm.assignExt(sName, sExt, ExeName : String);
Var Reg : TRegistry;
Begin
  Reg := TRegistry.Create;
  try
    with Reg do begin
      RootKey := HKEY_CLASSES_ROOT;
      OpenKey('\' + sName, True);
      WriteString('', sName + ' File');
      CloseKey;
      OpenKey(sName + '\DefaultIcon', True);
      WriteString('', ExeName + ',0');
      CloseKey;
      OpenKey(sName + '\shell\open\command', True);
      WriteString('', ExeName + ' "%1"');
      CloseKey;
      RootKey := HKEY_CLASSES_ROOT;
      OpenKey('\' + sExt, True);
      WriteString('', sName);
      CloseKey;
    end;
  finally
    Reg.CloseKey;
    Reg.Free;
  end;
end;

procedure TMainForm.mAssignPGNClick(Sender: TObject);
Begin
  assignExt(sCompoChess, '.pgn', Application.Exename);
  mAssignPGN.Enabled := false;
  Showmessage('OK.');
end;

procedure TMainForm.mNewFRCClick(Sender: TObject);
begin
  CreateMDIBrettChild(Nil, '', pgnAddGame, true);
end;

procedure TMainForm.mNextWinClick(Sender: TObject);
Var i : Integer;
begin
  i := MDIChildCount - 1;
  if i > 0 then
    MDIChildren[I].BringToFront;
end;

procedure TMainForm.BeliebigeSchwierigkeit1Click(Sender: TObject);
Var i1, i2, i, j : longint;
    ii, k : longint;
    s, s1 : String;
begin
  Screen.Cursor := crHourGlass;
  try
    if tacticPGN.PGNFile = '' then begin
      s := verzeichnis + 't1.kom';
      s1 := verzeichnis + 't1.pgn';
      if FileExists(s) then
        RenameFile(s, s1);
      tacticPGN.PGNFile := s1;
    end;
    if tacticPGN.PGNFile = '' then
      exit;  
    s := IntToStr((Sender as TMenuItem).Tag);
    if length(s) < 2 then begin
      i1 := 0;
      i2 := StrToInt(s);
    end
    else begin
      i1 := StrToInt(s[1]);
      i2 := StrToInt(s[2]);
    end;
    case i1 of
      0 : f1 := '0';
      1 : f1 := 'Z';
      2 : f1 := 'A';
      3 : f1 := 'H';
      4 : f1 := 'R';
      5 : f1 := 'F';
      6 : f1 := 'U';
      7 : f1 := 'W';
      8 : f1 := 'P';
      9 : f1 := 'X';
    end;
    case i2 of
      1 : f2 := '0';
      2 : f2 := '1';
      3 : f2 := '2';
      4 : f2 := '3';
    end;
    tacticPGN.Filtern;
    lf.Clear;
    Randomize;
    for ii := 1 to 10 do begin
      j := random(tacticPGN.ItemsVisibleCount);
      if lf.IndexOf(Pointer(j)) = -1 then
        lf.Add(Pointer(j))
      else begin
        for k := 0 to tacticPGN.ItemsVisibleCount - 1 do
        if lf.IndexOf(Pointer(k)) = -1 then begin
          lf.Add(Pointer(k));
          break;
        end;
        if k >= tacticPGN.ItemsVisibleCount - 1 then
          break;
      end;
    end;
    if lf.Count <> 0 then begin
      s := tacticPGN.GetGameAsString(tacticPGN.ListeIndexToDatabaseIndex(longint(lf[0])), i);
      mKombis.Enabled := false;
      CreateMDIBrettChild(tacticPGN, s, 0, false);
    end;
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TMainForm.tacticPGNFilterRequest(Sender: TObject;
  GameHeader: TEventData; var ShowThisGame: Boolean);
begin
  if not (
    ((f1 = '0') or (Pos(f1, GameHeader.Annotator) <> 0))
    and (
     (f2 = '0')
      or ((f2 = '1') and ((Pos('1', GameHeader.Annotator) <> 0) or (Pos('2', GameHeader.Annotator) <> 0)))
      or ((f2 = '2') and ((Pos('3', GameHeader.Annotator) <> 0)))
      or ((f2 = '3') and ((Pos('4', GameHeader.Annotator) <> 0) or (Pos('5', GameHeader.Annotator) <> 0)))
    )
  ) then
      ShowThisGame := false;
end;

procedure TMainForm.log(s : String);
begin
  Prot.writeOut(s);
end;

procedure TMainForm.logerr(s : String);
begin
  Prot.writeErr(s);
end;

procedure TMainForm.mToolbarBelowClick(Sender: TObject);
Var i : Integer;
begin
  mToolbarBelow.Checked := not mToolbarBelow.Checked;
end;

procedure TMainForm.mOtherLangClick(Sender: TObject);
var s : String;
begin
  if LO_Lng = LO_German then
    s := 'Sie knnen die Datei "' + sEnglishFile + '" in "IhreSprache.lng" umbenennen und den Inhalt bersetzen.' + #13 +
    'Sonderzeichen:' + #13 +
    '&& = verwendet in Men-Eintrgen - der nchste Buchstabe fungiert als Hotkey,' + #13 +
    ' = Zeilenumbruch.' + #13 +
    'Entfernen Sie keine Leerzeilen.' + #13 +
    'Nach dem nchsten Programmstart sollte der Eintrag "IhreSprache" im Men "Optionen - Sprache" erscheinen.'
  else
    s := 'You may rename the file "' + sEnglishFile + '" to "YourLanguage.lng" and translate it.' + #13 +
    'Special characters:' + #13 +
    '&& = used in menu captions - the next letter is the hotkey,' + #13 +
    ' = Line break.' + #13 +
    'Do NOT delete empty lines.' + #13 +
    'After the next program start the item "YourLanguage" should appear in the "Options - Language" menu.';
  MessageDlgLng(s, mtInformation, [mbOk], 0);  
end;

procedure TMainForm.mUninstallClick(Sender: TObject);

procedure removeLinks;
var Cmd: array[0..255] of Char;
    Macro, AName : String;
begin
  AName := sCompoChess;
  Macro := Format('[DeleteGroup(%s)]', [AName]) + #13#10;
  StrPCopy (Cmd, Macro);
  DDEClient.OpenLink;
  try
    DDEClient.ExecuteMacro(Cmd, False);
  finally
    DDEClient.CloseLink;
  end;
end;

procedure removeRegEntries;
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  try
    with Reg do begin
      RootKey := HKEY_CLASSES_ROOT;
      DeleteKey('\' + sCompoChess);
      RootKey := HKEY_CLASSES_ROOT;
      DeleteKey('\' + sCompoChessExt);
    end;
  finally
    Reg.Free;
  end;
end;

function TempPath: string;
var
  i: integer;
begin
  SetLength(Result, MAX_PATH);
  i := GetTempPath(Length(Result), PChar(Result));
  SetLength(Result, i);
   IncludeTrailingPathDelimiter(Result);
end;
                         
var sBat, s : String;
    f : TextFile;
    PrevInstance : hWnd;
    b : TForm;
begin
  if MessageDlgLng(LOGetMess(LOUninstallHint), mtWarning, mbYesNoCancel, 0)
    <> mrYes then exit;
  PrevInst := false;
  SendMessage(HWND_BROADCAST, WM_APPRUNNING, Application.Handle, 0);
  if PrevInst then begin   
    MessageDlg(LOGetMess(LOBeendenAlleInst), mtInformation, [mbOK], 0);
    exit;
  end;
  if isBrettOpened <> Nil then begin
    MessageDlg(LOGetMess(LOBeendenAlleBretter), mtInformation, [mbOK], 0);
    exit;
  end;
  try
    Prot.Free;
    Prot := Nil;
    removeLinks;
    removeRegEntries;
  except
  end;
  DeleteFile(verzeichnis + sLogFile);
  DeleteFile(verzeichnis + sEnglishFile);
  DeleteFile(verzeichnis + sIniFileName);
  MessageDlgLng(LOGetMess(LOUninstallDone), mtInformation, [mbOk], 0);
  try
    sBat := TempPath + uninstallbatfile;
    assignFile(f, sBat);
    rewrite(f);
    writeln(f, '@echo off');
    writeln(f, ':1');
    writeln(f, 'del "' +  Application.Exename + '"');
    writeln(f, 'if exist "' +  Application.Exename + '" goto 1');
    s := verzeichnis;
    if (s <> '') and (s[length(s)] = '\') then
      s := copy(s, 1, length(s) - 1);
    writeln(f, 'rmdir "' + s + '"');
    writeln(f, 'del "' + sBat + '" | cls'); 
    closeFile(f);
    ShellExecute(handle, 'open', PChar(sBat), '', '', SW_SHOWMINIMIZED)
  finally
    doNotWriteIni := true;
    Close;
  end;
end;

end.
