unit udgtboard_demo;

interface

uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
     Dialogs, udgtboard, ExtCtrls, StdCtrls;

type TForm1 = class(TForm)
     Panel1: TPanel;
     Memo1: TMemo;
     Button1: TButton;
     Button2: TButton;
     Button3: TButton;
     DGTBoard1: TDGTBoard;
     ComboBox1: TComboBox;
     procedure Button2Click(Sender: TObject);
     procedure Button3Click(Sender: TObject);
     procedure DGTBoard1BoardPositionChanged(Sender: TObject);
     procedure DGTBoard1RotationChanged(Sender: TObject);
     procedure DGTBoard1StableBoardPosition(Sender: TObject);
     procedure DGTBoard1Error(Sender: TObject; ErrorNumber: Integer; ErrorMessage: String);
     procedure Button1Click(Sender: TObject);
     procedure ComboBox1Change(Sender: TObject);
   private
     stop : Boolean;
     function getPosition : String;
   end;

var Form1 : TForm1;

implementation
{$R *.dfm}

function TForm1.getPosition : String;
var i : integer;
begin
  Result := '';
  For i := 0 to 63 do Result := Result + IntToStr(DGTBoard1.Board[i]) + ',';
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if DGTBoard1.Start <> 0 then begin
    MessageDlg('BoardInit failed.', mtError, [mbOk], 0);
    exit;
  end;
  Button2.Enabled := false; Button1.Visible := false; Button3.Enabled := true;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  DGTBoard1.Stop;
  stop := true;
  Button3.Enabled := false; Button2.Enabled := true; Button2.Visible := true;
  Button1.Enabled := true; Button1.Visible := true;
end;

procedure TForm1.DGTBoard1BoardPositionChanged(Sender: TObject);
begin
  Memo1.Lines.Add('BoardPositionChanged ' + getPosition);
end;

procedure TForm1.DGTBoard1RotationChanged(Sender: TObject);
begin
  Memo1.Lines.Add('RotationChanged ' + getPosition);
end;

procedure TForm1.DGTBoard1StableBoardPosition(Sender: TObject);
begin
  Memo1.Lines.Add('StableBoardPosition ' + getPosition);
end;

procedure TForm1.DGTBoard1Error(Sender: TObject; ErrorNumber: Integer; ErrorMessage: String);
begin
  MessageDlg(ErrorMessage, mtError, [mbOk], 0);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if DGTBoard1.BoardInit <> 0 then begin
    MessageDlg('BoardInit failed.', mtError, [mbOk], 0);
    exit;
  end;
  stop := false;
  Button1.Enabled := false; Button2.Visible := false; Button3.Enabled := true;
  while not stop do begin
    DGTBoard1.poll;
    sleep(200);
    Application.ProcessMessages;
  end;
  DGTBoard1.BoardClose;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  DGTBoard1.ComPort := Combobox1.ItemIndex + 1;
end;

end.
