unit Schach;

{--------------------------------------------------------------------------------------
*** Version 7.3 ***
Delphi components for the development of chess programs

Some comments of the methodes you can find in the various .pas files
(sorry for my terrible English)

The components TBrett, TNotation, TPGN, TQRChessRichText,
TTimeLabel and TChessDatabase are public domain.

TMiniMax is based on the program "Minimax"
by Ch. Donninger und D. Steinwender.
If you use this component, you must mention these authors and
keep the name "Minimax" for your analysis engine.
You may change the source code of Minimax.

TDGTBoard is freeware.
The dll for this component is provided by "DGTProjects". 

Please note that originally these components were a part of a program
and not designed to be published and to be flexible,
and so they cannot easily be adjusted by inherited functions, etc.
However, the functionallity is already very high.
---------------------------------------------------------------------------------}

{$B-}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls;

procedure Register;

implementation

uses Brett, MiniMax, Notation, PGN, ChessPrint, TimeLabel, ChessDatabase, udgtboard;

procedure Register;
begin
  RegisterComponents('Schach', [TBrett]);
  RegisterComponents('Schach', [TDGTBoard]);
  RegisterComponents('Schach', [TMiniMax]);
{$IFDEF WIN32}
  RegisterComponents('Schach', [TNotation]);
  RegisterComponents('Schach', [TPGN]);
  RegisterComponents('Schach', [TChessdatabase]);
{
Remove the next line and the "Chessprint" unit if you have not installed the "QReport" component
(maybe it is not available in some standard editions of Delphi)
}
  RegisterComponents('Schach', [TQRChessRichText]);
{$ENDIF}
  RegisterComponents('Schach', [TTimeLabel]);
end;

end.
