unit schachfonts;

interface

{
if you add a font, you must also add it in the method "PostoSFDia" of SchachProcs.Pas.
The fonts are identified by name - see below: "Schachfonts"
}

type

  TChessFontChars = record
      sfRo1, sfRo2, sfRo3 ,sfRo4 ,sfRo5 ,sfRo6 ,sfRo7 ,sfRo8,  {edge}
      sfRl1, sfRl2, sfRl3, sfRl4, sfRl5, sfRl6, sfRl7, sfRl8,
      sfRr1, sfRr2, sfRr3, sfRr4, sfRr5, sfRr6, sfRr7, sfRr8,
      sfRu1, sfRu2, sfRu3, sfRu4, sfRu5, sfRu6, sfRu7, sfRu8,
      sfElo,  {corners}
      sfEro,
      sfElu,
      sfEru,
      sfwFl,  {empty squares}
      sfsFl,
      sfwFwK, sfwFsK,{pieces}
      sfsFwK, sfsFsK,
      sfwFwD, sfwFsD,
      sfsFwD, sfsFsD,
      sfwFwT, sfwFsT,
      sfsFwT, sfsFsT,
      sfwFwL, sfwFsL,
      sfsFwL, sfsFsL,
      sfwFwS, sfwFsS,
      sfsFwS, sfsFsS,
      sfwFwB, sfwFsB,
      sfsFwB, sfsFsB : string;
   end;
   PChessFontChars = ^TChessFontChars;


const
   sfChars1Echecs : TChessFontChars =
      (sfRo1 : ''; sfRo2 : ''; sfRo3 : ''; sfRo4 : ''; sfRo5 : ''; sfRo6 : ''; sfRo7 : ''; sfRo8 : '';  {Edge}
      sfRl1  : #180; sfRl2  : #180; sfRl3  : #180; sfRl4  : #180; sfRl5  : #180; sfRl6  : #180; sfRl7  : #180; sfRl8  : #180;
      sfRr1  : #222; sfRr2  : #222; sfRr3  : #222; sfRr4  : #222; sfRr5 : #222; sfRr6  : #222; sfRr7  : #222; sfRr8  : #222;
      sfRu1  : #131; sfRu2  : #131; sfRu3  : #131; sfRu4 : #131; sfRu5  : #131; sfRu6  : #131; sfRu7  : #131; sfRu8  : #131;
      sfElo : #241; {corners}
      sfEro : #242;
      sfElu : #243;
      sfEru : #244;
      sfwFl : #32;  {empty squares}
      sfsFl : #58;
      sfwFwK : 'r';    sfwFsK : 'R';   {pieces}
      sfsFwK : '01r';  sfsFsK : '01R';
      sfwFwD : 'de';   sfwFsD : 'D';
      sfsFwD : '23de'; sfsFsD : '23D';
      sfwFwT : 't';    sfwFsT : 'T';
      sfsFwT : '45t';  sfsFsT : '45T';
      sfwFwL : 'f';    sfwFsL : 'F';
      sfsFwL : '67f';  sfsFsL : '67F';
      sfwFwS : 'c';    sfwFsS : 'C';
      sfsFwS : '89c';  sfsFsS : '89C';
      sfwFwB : 'p';    sfwFsB : 'P';
      sfsFwB : '()p';  sfsFsB : '()P');

      sfCharsDiagramTTHabsburg : TChessFontChars =
      (sfRo1 : 'A'; sfRo2 : 'B'; sfRo3 : 'C'; sfRo4 : 'D'; sfRo5 : 'E'; sfRo6 : 'F'; sfRo7 : 'G'; sfRo8 : 'H';  {Rand}
      sfRl1  : '1'; sfRl2  : '2'; sfRl3  : '3'; sfRl4  : '4'; sfRl5  : '5'; sfRl6  : '6'; sfRl7  : '7'; sfRl8  : '8';
      sfRr1  : '!'; sfRr2  : '"'; sfRr3  : '#'; sfRr4  : '$'; sfRr5 : '%'; sfRr6  : '&'; sfRr7  : ''''; sfRr8  : '(';
      sfRu1  : 'a'; sfRu2  : 'b'; sfRu3  : 'c'; sfRu4 : 'd'; sfRu5  : 'e'; sfRu6  : 'f'; sfRu7  : 'g'; sfRu8  : 'h';
      sfElo : 'X'; {Ecken}
      sfEro : 'Y';
      sfElu : 'x';
      sfEru : 'y';
      sfwFl : '-';  {empty squares}
      sfsFl : '+';
      sfwFwK : 'K';    sfwFsK : 'k';   {pieces}
      sfsFwK : 'mK';  sfsFsK : 'mk';
      sfwFwD : 'Q';   sfwFsD : 'q';
      sfsFwD : 'wQ'; sfsFsD : 'wq';
      sfwFwT : 'R';    sfwFsT : 'r';
      sfsFwT : 'tR';  sfsFsT : 'tr';
      sfwFwL : 'L';    sfwFsL : 'l';
      sfsFwL : 'vL';  sfsFsL : 'vl';
      sfwFwS : 'N';    sfwFsS : 'n';
      sfsFwS : 'sN';  sfsFsS : 'sn';
      sfwFwB : 'P';    sfwFsB : 'p';
      sfsFwB : 'zP';  sfsFsB : 'zp');

      sfCharsChess_Berlin : TChessFontChars =
      (sfRo1 : '2'; sfRo2 : '2'; sfRo3 : '2'; sfRo4 : '2'; sfRo5 : '2'; sfRo6 : '2'; sfRo7 : '2'; sfRo8 : '2';  {Rand}
      sfRl1  : '4'; sfRl2  : '4'; sfRl3  : '4'; sfRl4  : '4'; sfRl5  : '4'; sfRl6  : '4'; sfRl7  : '4'; sfRl8  : '4';
      sfRr1  : '5'; sfRr2  : '5'; sfRr3  : '5'; sfRr4  : '5'; sfRr5 : '5'; sfRr6  : '5'; sfRr7  : '5'; sfRr8  : '5';
      sfRu1  : '8'; sfRu2  : '8'; sfRu3  : '8'; sfRu4 : '8'; sfRu5  : '8'; sfRu6  : '8'; sfRu7  : '8'; sfRu8  : '8';
      sfElo : '1'; {Ecken}
      sfEro : '3';
      sfElu : '7';
      sfEru : '9';
      sfwFl : ' ';  {empty squares}
      sfsFl : '+';
      sfwFwK : 'k';    sfwFsK : 'l';   {pieces}
      sfsFwK : 'K';  sfsFsK : 'L';
      sfwFwD : 'q';   sfwFsD : 'w';
      sfsFwD : 'Q'; sfsFsD : 'W';
      sfwFwT : 'r';    sfwFsT : 't';
      sfsFwT : 'R';  sfsFsT : 'T';
      sfwFwL : 'b';    sfwFsL : 'n';
      sfsFwL : 'B';  sfsFsL : 'N';
      sfwFwS : 'h';    sfwFsS : 'j';
      sfsFwS : 'H';  sfsFsS : 'J';
      sfwFwB : 'p';    sfwFsB : 'o';
      sfsFwB : 'P';  sfsFsB : 'O');


      sfCharsChess_Merida : TChessFontChars =
      (sfRo1 : '2'; sfRo2 : '2'; sfRo3 : '2'; sfRo4 : '2'; sfRo5 : '2'; sfRo6 : '2'; sfRo7 : '2'; sfRo8 : '2';  {Rand}
      sfRl1  : '4'; sfRl2  : '4'; sfRl3  : '4'; sfRl4  : '4'; sfRl5  : '4'; sfRl6  : '4'; sfRl7  : '4'; sfRl8  : '4';
      sfRr1  : '5'; sfRr2  : '5'; sfRr3  : '5'; sfRr4  : '5'; sfRr5 : '5'; sfRr6  : '5'; sfRr7  : '5'; sfRr8  : '5';
      sfRu1  : '8'; sfRu2  : '8'; sfRu3  : '8'; sfRu4 : '8'; sfRu5  : '8'; sfRu6  : '8'; sfRu7  : '8'; sfRu8  : '8';
      sfElo : '1'; {Ecken}
      sfEro : '3';
      sfElu : '7';
      sfEru : '9';
      sfwFl : ' ';  {empty squares}
      sfsFl : '+';
      sfwFwK : 'k';    sfwFsK : 'l';   {pieces}
      sfsFwK : 'K';  sfsFsK : 'L';
      sfwFwD : 'q';   sfwFsD : 'w';
      sfsFwD : 'Q'; sfsFsD : 'W';
      sfwFwT : 'r';    sfwFsT : 't';
      sfsFwT : 'R';  sfsFsT : 'T';
      sfwFwL : 'b';    sfwFsL : 'v';
      sfsFwL : 'B';  sfsFsL : 'V';
      sfwFwS : 'n';    sfwFsS : 'm';
      sfsFwS : 'N';  sfsFsS : 'M';
      sfwFwB : 'p';    sfwFsB : 'o';
      sfsFwB : 'P';  sfsFsB : 'O');

  TSchachfonts : array[0..3] of string = ('1Echecs', 'DiagramTTHabsburg', 'Chess Berlin', 'Chess Merida');

implementation

end.
